#include "debugitem.h"

DebugItem::DebugItem(QObject *parent) : QObject(parent)
{
    clean();
}

DebugItem::~DebugItem()
{
    clean();
}

DebugItem::DebugItem(const DebugItem & item) : QObject()
{
    copyData(item);
}

DebugItem & DebugItem::operator= (const DebugItem & item)
{
    copyData(item);
    return *this;
}

void DebugItem::clean()
{
    m_macType = 0;
    m_showPriority = 0;
    m_name.clear();
    m_topImageName.clear();
    m_enumFunction = 0;
}

void DebugItem::copyData(const DebugItem &item)
{
    if (this != &item)
    {
        this->m_macType = item.m_macType;
        this->m_showPriority = item.m_showPriority;
        this->m_name = item.m_name;
        this->m_topImageName = item.m_topImageName;
        this->m_enumFunction = item.m_enumFunction;
    }
}
