#include "AutoPosPunchMachine.h"
//定制冲孔机（自动定位冲孔机）单头 双头 四头 旋转
AutoPosPunchMachine::AutoPosPunchMachine()
{
    //添加各种参数到列表中
    initRootParasList();
    initRootHMIConfigurationList(m_allParasList);//超级用户界面配置
    initRootIOTConfigurationList(m_allParasList); //超级用户物联网配置
    initPatternsParasList();
    initSoftwareParasList(m_allParasList);
    initTimeParasList(m_allParasList);
    initPunchCommonFunParasList(m_allParasList);
    initMcParasList();
    initWkParasList();

    //初始化控制动作列表
    initOutCtrlList();

    //初始化快捷功能列表
    initShortCutList();

    //初始化辅助功能列表
    initAssistList();

    //初始化花样设置功能列表
    initPatternSetList();

    //初始化参数设置功能列表
    initParaSetList();

    //初始化传感器列表
    initSensorList();

    //初始化错误代码和状态列表
    initErrorCodeAndStateList();
}

AutoPosPunchMachine::~AutoPosPunchMachine()
{

}

//超级用户参数(包括机器参数、工作参数)
void AutoPosPunchMachine::initRootParasList()
{
    //超级用户参数---------------------------
    //超级用户参数-界面配置；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_HMICONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("HMI Configuration"),//界面配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0000 , factory));

    //超级用户参数-界面进入调试模式；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DEBUGMODE, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Interface debug mode"),//界面进入调试模式
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , root));

    //超级用户参数-删除config.ini配置文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETEINI, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete configure file"),//删除配置文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , root));

    //超级用户参数-重置花样配置-删除花样fcg文件影响fileid的数据;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_CLEARPATTERNFCG_FILEID, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete pattern configuration"),//删除花样配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001, factory));

    //超级用户参数-导入csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IMPORTCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Import CSV file"),//导入csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-删除csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETECSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete CSV file"),//删除csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-重置安装调试进度；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_RESETCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Reset CSV file"),//重置安装调试进度
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-机器参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_MACHINEPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Machine parameters"),//机器参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0002, factory));

    //超级用户参数-工作参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_WORKPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Work parameters"),//工作参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0003, factory));

    //超级用户参数-物联网配置;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IOTCONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("InternetofThings  configuration"),//物联网配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x000D, factory));

    //超级用户界面配置参数-行程矫正；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_TROKECORRECTION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        QCoreApplication::translate("GLOBAL", "Stroke correction"),//行程矫正
                                        0, 0, 0, 0, 0, "", "", "",
                                        0, 0, 0x000D, factory));
}

//花样参数
void AutoPosPunchMachine::initPatternsParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    //花样参数-花样设置参数-翻转式样；单位：无 ，范围0-7，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATESTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flip style"),//翻转式样
                                        0, 0, 7, 0, 0, tr(""), tr(""),
                                        tr("normalP:0;nRight90P:1;nRight180P:2;nRight270P:3;mirrorP:4;mRight90P:5;mRight180P:6;mRight270P:7"),
                                        0, 0, 0x0001, operate));

    //花样参数-花样设置参数-水平翻转样式；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_HORIZONTALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Horizontal flip style"),//水平翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-垂直翻转式样；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_VERTICALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("vertical flip style"),//垂直翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-旋转角度；单位：° ，范围0-90，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATEANGLE, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation angle"),//旋转角度
                                        0, 0, 90, 0, 0, cod->toUnicode("°"), tr(""),//度
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-需要分割的针步长度；单位：mm，范围3-20，默认7
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_SPLITSTITCHLENGTH, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of the stitch that needs to be split"),//需要分割的针步长度
                                        700, 300, 2000, 700, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数---------------------------
}

void AutoPosPunchMachine::initMcParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 主轴启动停止转速, 范围 1--300，单位r/min，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        109, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("punching spindle start and stop speed"),//冲孔主轴启动停止转速
                                        100, 1, 300, 100, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // 主轴归零转速, 范围 1--3000，单位r/min，默认 120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("main punching shaft zeroing speed"),//主冲孔轴归零转速
                                        120, 1, 3000, 120, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 主轴运转转速, 范围 1--3000，单位r/min，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        111, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle running speed"),//主轴运转转速
                                        300, 1, 3000, 300, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 主轴运转加速度, 范围 1--100，单位r/ss，默认 50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        112, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("spindle punching speed"),//主轴冲孔运转加速度
                                        50, 1, 100, 50, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 主轴刹车加速度, 范围 1--100，单位r/ss，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        113, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("spindle punching brake acceleration"),//主轴冲孔刹车加速度
                                        100, 1, 100, 100, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy启动停止速度, 范围 1--100，单位mm/s，默认 10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        100, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY start stop speed"),//XY启动停止速度
                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy归零运行速度, 范围 1--100，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        101, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY zero run speed"),//XY归零运行速度
                                        100, 1, 100, 100, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy空走运行速度, 范围 1--1000，单位mm/s，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        102, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY idle running speed"),//XY空走运行速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy行走加速度, 范围 1--10000，单位mm/s2，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        103, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY walking acceleration"),//XY行走加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy刹车加速度 1--10000，单位mm/s2，默认 10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        104, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY braking acceleration"),//XY刹车加速度
                                        10000, 1, 10000, 10000, 0, tr("mm/s2"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy手动移动速度1, 范围 1--1000，单位mm/s，默认 10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        105, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 1"),//XY手动移动速度1
                                        10, 1, 1000, 10, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy手动移动速度2, 范围 1--1000，单位mm/s，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        106, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 2"),//XY手动移动速度2
                                        100, 1, 1000, 100, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy手动移动速度3, 范围 1--1000，单位mm/s，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 3"),//XY手动移动速度3
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // xy最高移动速度, 范围 1--1000，单位mm/s，默认 300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        108, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY maximum movement speed"),//XY最高移动速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // x框传感器坐标, 范围 S32_MIN--S32_MAX，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        50, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X frame sensor coordinates"),//x框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // y框传感器坐标, 范围 S32_MIN--S32_MAX，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        51, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y frame sensor coordinates"),//y框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 主轴归零补偿角度, -1000--1000, 单位 0.01度，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        146, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle zero compensation angle"),//主轴归零补偿角度
                                        200, -1000, 1000, 200, 2,cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // X轴归零补偿, -1000--1000, 单位 0.01mm，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        147, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X-axis zero compensation"),//X轴归零补偿
                                        200, -1000, 1000, 200, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    //y轴归零补偿, -1000--1000, 单位 0.01mm，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        148, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y-axis zero compensation"),//Y轴归零补偿
                                        200, -1000, 1000, 200, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // X间隙补偿,范围-200--200 单位 0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X backlash compensation"),//X间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // Y间隙补偿,范围-200--200 单位 0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y backlash compensation"),//Y间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // 机头个数,范围0-100  单位 个，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of handpieces"),//机头个数
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 冲孔每头机针个数,范围0-100  单位 个，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        5, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of punch hand"),//冲孔每头机针个数
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_DETECT,
                                        36, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Infrared device configuration"),// 红外装置配置
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    ///限位参数
    // x可移动区域负边界(X-), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        70, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area negative border"),//X可移动区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // x可移动区域正边界(X+), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        71, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area positive border"),//X可移动区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // x可冲孔区域负边界(X-), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        88, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Punchable area negative boundary"),//X可冲孔区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // x可冲孔区域正边界(X+), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        89, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Positive boundary of punchable area"),//X可冲孔区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // y可移动区域负边界(Y-), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area negative boundary"),//Y可移动区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // y可移动区域正边界(Y+), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area positive boundary"),//Y可移动区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));
    // y可冲孔区域负边界(Y-), 范围 -2147483648--2147483647，单位0.01mm

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        90, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y negative boundary of punchable area"),//Y可冲孔区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    // y可冲孔区域正边界(Y+), 范围 -2147483648--2147483647，单位0.01mm
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        91, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y positive boundary of punchable area"),//Y可冲孔区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x000E, operate));

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {
        // 冲头旋转启动停止速度, 范围 1--720, 单位 deg/s(度/秒)，默认 10
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            156, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Starting and stopping speed of punch rotation"),//冲头旋转启动停止速度
                                            10, 1, 720, 10, 0, tr("deg/s"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));

        // 冲头旋转归零速度, 1--720, 单位 deg/s(度/秒)，默认 50
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            157, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Zero speed of punch rotation"),//冲头旋转归零速度
                                            50, 1, 720, 50, 0, tr("deg/s"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));

        // 冲头旋转运转速度, 范围 1--720, 单位 deg/s(度/秒)，默认 360
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            158, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Rotating speed of punch"),//冲头旋转运转速度
                                            360, 1, 720, 360, 0, tr("deg/s"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));

        // 冲头旋转运动加速度,  范围 1--10000, 单位 deg/s(度/秒方)，默认 500
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            159, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Acceleration of punch rotation motion"),//冲头旋转运动加速度
                                            500, 1, 10000, 500, 0, tr("deg/ss"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));

        // 冲头旋转刹车加速度,  范围 1--10000, 单位 deg/s(度/秒方)，默认 5000
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            160, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Ram rotation brake acceleration"),//冲头旋转刹车加速度
                                            5000, 1, 10000, 5000, 0, tr("deg/ss"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));

        // 冲头旋转最高速度, 范围 1--2000，单位 deg/s，默认 720
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_MACH,
                                            MC_SORT_SPEED,
                                            161, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Maximum speed of punch rotation"),//冲头旋转最高速度
                                            720, 1, 2000, 720, 0, tr("deg/s"), tr(""),
                                            tr(""), 0, 0, 0x000E, operate));
    }
}

void AutoPosPunchMachine::initWkParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    int highFlag = g_pSettings->readFromIniFile("AUFUS/highSpeed").toInt() ;

    //操作参数
    // 吸尘器启动延时，单位秒,,0--10s，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        84, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner start delay"),//吸尘器启动延时
                                        0, 0, 10, 0, 0, tr("s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0001, operate));

    // 吸尘器关闭延时，单位秒,0--10s，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        40, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner off delay"),//吸尘器关闭延时
                                        0, 0, 10, 0, 0, tr("s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0002, operate));

    // 冲孔吸尘器启动持续时间，范围0-100，单位s，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        181, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Duration of vacuuming"),//吸尘持续时长
                                        5, 0, 100, 5, 0, tr("s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0003, operate));

    // 冲孔换色间距，范围0-10000，单位mm,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        186, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching color change spacing"),// 冲孔换色间距
                                        0, 0, 10000, 0, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔画笔工作模式，0，自动；1，手动，默认0.
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        187, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Working mode of punching brush"),// 冲孔画笔工作模式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("automatic:0;Manual:1"), 0, 0, 0x018A, operate));

    // 冲孔主轴最大运行速度，范围0-2000，单位r/min,默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        188, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Maximum running speed of punching spindle"),// 冲孔主轴最大运行速度
                                        1000, 0, 2000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        197, 0, 0, PARA_VALUE_TYPE_SW,
                                        tr("Automatic start angle adjustment"),//自动起始角度调整
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 单片工作时间显示模式，0，不显示；1，单片工作时间；2，累计工作时间
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        199, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Single chip working time display mode"),// 单片工作时间显示模式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("not display:0;monolithic:1;accumulative total:2"),
                                        0, 0, 0x018A, operate));

    if(highFlag == 0)
    {
        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            220, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1000 rpm"),//冲孔自动调整角度 1000 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            221, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1100 rpm"),//冲孔自动调整角度 1100 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            222, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1200 rpm"),//冲孔自动调整角度 1200 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            223, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1300 rpm"),//冲孔自动调整角度 1300 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            224, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1400 rpm"),//冲孔自动调整角度 1400 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            225, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1500 rpm"),//冲孔自动调整角度 1500 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));
    }
    else if(highFlag == 1)
    {
        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            220, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1600 rpm"),//冲孔自动调整角度 1600 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            221, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1700 rpm"),//冲孔自动调整角度 1700 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            222, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1800 rpm"),//冲孔自动调整角度 1800 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            223, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1900 rpm"),//冲孔自动调整角度 1900 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            224, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 2000 rpm"),//冲孔自动调整角度 2000 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            225, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 2100 rpm"),//冲孔自动调整角度 2100 rpm
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));
    }

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        226, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 4-5mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        227, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 5-6mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        228, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 6-7mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        229, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 7-8mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        230, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 8-9mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        231, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 9-14mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        232, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 14+mm"),// 冲孔运行速度限制
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            233, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 1"),//冲孔旋转角度补偿1
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            234, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 2"),//冲孔旋转角度补偿2
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            235, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 3"),//冲孔旋转角度补偿3
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            236, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 4"),//冲孔旋转角度补偿4
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            237, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 5"),//冲孔旋转角度补偿5
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔1旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            238, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 1 rotation angle compensation 6"),//冲孔旋转角度补偿6
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            245, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 1"),//冲孔2旋转角度补偿1
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            246, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 2"),//冲孔2旋转角度补偿2
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            247, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 3"),//冲孔2旋转角度补偿3
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            248, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 4"),//冲孔2旋转角度补偿4
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            249, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 5"),//冲孔2旋转角度补偿5
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));

        // 冲孔2旋转角度补偿，范围-36000--36000，单位0.01度，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            250, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching 2 rotation angle compensation 6"),//冲孔2旋转角度补偿6
                                            0, -36000, 36000,0, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x018A, operate));
    }

    if(highFlag == 0)
    {
        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            239, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1000 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            240, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1100 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            241, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1200 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            242, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1300 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            243, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1400 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            244, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1500 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));
    }
    else if(highFlag == 1)
    {
        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            239, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1600 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            240, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1700 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            241, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1800 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            242, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 1900 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            243, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 2000 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));

        // 冲孔自动调整角度，单位度，范围0-360，默认0
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SPEED,
                                            244, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("adjustment angle 2100 rpm"),//冲孔自动调整角度
                                            0, 0, 360, 0, 0,cod->toUnicode("°"), tr(""),
                                            tr(""), 0, 0, 0x018A, operate));
    }

    // 冲孔吸尘器启动间隔，范围0-500，单位s，默认60
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        182, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching vacuum cleaner start interval"),//吸尘器启动间隔
                                        60, 0, 500, 60, 0, tr("s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0004, operate));

    //拉料偏移值,范围0-500000，默认90000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        89, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("1 tool punching tool life alarm"),//1刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0005, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        90, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("2 tool punching tool life alarm"),//2刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0006, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        91, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("3 tool punching tool life alarm"),//3刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0007, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        92, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("4 tool punching tool life alarm"),//4刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0008, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        93, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("5 tool punching tool life alarm"),//5刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0009, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        94, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("6 tool punching tool life alarm"),//6刀位冲刀寿命报警
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0010, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("first head"),//  第一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0170, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("second head"),//  第二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0171, operate));

    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            100, 3, 0, PARA_VALUE_TYPE_SW,
                                            tr("third head"),//  第三个机头
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0172, operate));

        // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            100, 4, 0, PARA_VALUE_TYPE_SW,
                                            tr("fourth head"),//  第四个机头
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0173, operate));
    }

    // 产量预设, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        33, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Production preset"),// 产量预设
                                        0, 0, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x012A, operate));

    // 冲孔主轴工作转速, 范围 1--3000，单位r/min，默认 2000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        41, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle working speed"),//冲孔主轴工作转速
                                        2000, 1, 3000, 2000, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0011, operate));
    // 冲孔加速度, 1--200, 单位r/ss , 默认20
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        42, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching acceleration"),//冲孔加速度
                                        20, 1, 200, 20, 0, tr("r/ss"), tr(""),
                                        tr(""),
                                        0, 0, 0x0011, operate));

    // 冲孔动框方式, 位图
    // bit0 = 0, xy连续动框; bit0 = 1, xy间歇式动框;
    // bit1 = 0, xy间歇式脉冲无加减速; bit1 = 1, xy间歇式脉冲正弦加减速;
    // bit2 = 0, 冲孔连续旋转; bit2 = 1,冲孔间接旋转;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        43, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching and moving frame method"),// 冲孔动框方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("xy continuous frame:0;xy intermittent frame:1"), 0, 0, 0x0012, operate));  // bit0 = 0, xy连续动框; bit0 = 1, xy间歇式动框;

    // bit1 = 0, xy间歇式脉冲无加减速; bit1 = 1, xy间歇式脉冲正弦加减速;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        43, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("XY moving frame acceleration and deceleration method"),// XY动框加减速方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("xy intermittent pulse without acceleration and deceleration:0;xy intermittent pulse sine acceleration and deceleration:1"), 0, 0, 0x0013, operate));   // bit1 = 0, xy间歇式脉冲无加减速; bit1 = 1, xy间歇式脉冲正弦加减速;

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        43, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching Rotation"),// 冲孔旋转方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Punching continuous rotation:0;Punching indirect rotation:1"), 0, 0, 0x0014, operate));   // bit2 = 0, 冲孔连续旋转; bit2 = 1,冲孔间接旋转;

    // 冲孔动框起始角度, 0--36000, 单位 0.01度，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        44, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Starting angle of punching frame"),//冲孔动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0015, operate));

    // 冲孔动框持续角度, 0--36000, 单位 0.01度，默认 15000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        45, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Persistence angle of punching frame"),//冲孔动框持续角度
                                        15000, 0, 36000,15000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0015, operate));

    // 软件限位; 位图选择, 0, 不允许; 1, 允许;
    // bit0, xy移动;
    // bit4, 冲孔落杆限制;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("xy move"),// xy移动
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0017, factory));

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {
        // 冲孔旋转减速最小偏差角度,单位度，范围0--180,默认 180
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            63, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Minimum deviation angle for punching rotation deceleration"),//冲孔旋转减速最小偏差角度
                                            180, 0, 180,180, 0, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x0015, operate));

        // 冲孔旋转持续角度, 0--36000, 单z位 0.01度，默认 36000
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            64, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Continuous angle of punching rotation"),//冲孔旋转持续角度
                                            36000, 0, 36000,36000, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 1, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 1 rotation control"),//冲孔机头1旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 2, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 2 rotation control"),//冲孔机头2旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 3, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 3 rotation control"),//冲孔机头3旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 4, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 4 rotation control"),//冲孔机头4旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 5, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 5 rotation control"),//冲孔机头5旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));

        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            68, 6, 0, PARA_VALUE_TYPE_SW,
                                            tr("Punching machine head 6 rotation control"),//冲孔机头6旋转控制
                                            0, 0, 1, 0, 0, tr(""), tr(""),
                                            tr(""), 0, 0, 0x0015, operate));
    }

    // 更换冲头计数值，范围0-1000000，单位 次，默认500000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        178, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Replace the punch count"),// 更换冲头计数值
                                        500000, 0, 1000000, 500000, 0, tr("bout"), tr(""),
                                        tr(""),
                                        0, 0, 0x0020, operate));

    // 换色启动方式,0,自动换色，自动启动；1，自动换色，手动启动；2，手动换色，手动启动
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        71, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Color change start method"),//换色启动方式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("Automatic color Automatic start:0;Automatic color Manual start:1;Manual color Manual start:2"),
                                        0, 0, 0x0020, operate));

    //  X绣框换向补偿,范围-1000--1000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X embroidery frame reversing compensation"),//X绣框换向补偿
                                        0, -1000, 1000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // Y绣框换向补偿,范围-1000--1000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y embroidery frame reversing compensation"),//Y绣框换向补偿
                                        0, -1000, 1000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // 冲孔跳针变越框针数,范围0-100，单位，针，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        79, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching jump stitches to change the number of frame stitches"),//冲孔跳针变越框针数
                                        5, 0, 100, 5, 0, tr("Needle"), tr(""),
                                        tr(""),
                                        0, 0, 0x0021, operate));

    // 倒车工作模式，0，普通模式；1，点动模式；2,持续点动模式
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        81, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Reversing working mode"),//倒车工作模式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("normal mode:0;Jog mode:1;Continuous jog mode:2"),
                                        0, 0, 0x0022, operate));

    // 特殊针位选择，0，无；1-9，1-9针位
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        82, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle position selection"),//特殊针位选择
                                        0, 0, 9, 0, 0, tr(""), tr(""),
                                        tr("none:0;1 needle position:1;2 needle position:2;3 needle position:3;4 needle position:4;5 needle position:5;6 needle position:6;7 needle position:7;8 needle position:8;9 needle position:9"),
                                        0, 0, 0x0023, operate));

    // 特殊针位功能，0，雕孔；1，画笔
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        83, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle position function"),//特殊针位功能
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Carved hole:0;brush:1"),
                                        0, 0, 0x0024, operate));

    // 换色速度，范围1-2000，单位mm/s,默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        99, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Color change speed"),// 换色速度
                                        200, 1, 2000, 200, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0025, operate));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("light curtain"),// 光幕
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0026, factory));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("air pressure"),// 气压
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0027, factory));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 7, 0, PARA_VALUE_TYPE_SW,
                                        tr("Safety guardrail"),// 安全护栏
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0027, factory));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 8, 0, PARA_VALUE_TYPE_SW,
                                        tr("Tricolor lamp"),// 三色灯
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0027, factory));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 9, 0, PARA_VALUE_TYPE_SW,
                                        tr("Oil pump alarm"),// 油泵报警
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0027, factory));

    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 10, 0, PARA_VALUE_TYPE_SW,
                                        tr("Vacuum cleaner alarm"),// 吸尘器报警
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0027, factory));

    // 冲孔主轴启动慢动转速, 范围 1--2000，单位r/min，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        169, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle start jogging speed"),// 冲孔主轴启动慢动转速
                                        500, 1, 2000, 500, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0028, operate));

    // X工作范围，范围0-500000，单位0.01mm，默认90000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        174, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Working Range"),// X工作范围
                                        90000, 0, 500000, 90000, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0029, operate));

    // Y工作范围，范围0-500000，单位0.01mm，默认60000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Working Range"),// Y工作范围
                                        60000, 0, 500000, 60000, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0030, operate));

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {
        // 冲孔旋转传感器角度，范围-36000--36000，单位0.01度，默认9000
        m_allParasList.append(makeAParaItem(0,
                                            PARA_TYPE_WORK,
                                            MC_SORT_SETTING,
                                            176, 0, 0, PARA_VALUE_TYPE_INT,
                                            tr("Punching rotation sensor angle"),//冲孔旋转传感器角度
                                            9000, -36000, 36000,9000, 2, cod->toUnicode("°"), tr(""),
                                            tr(""),
                                            0, 0, 0x0030, operate));
    }

    // 冲孔动框最高速度，范围1-1000，单位mm/s，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Maximum speed of punching and moving frame"),// 冲孔动框最高速度
                                        200, 0, 1000, 200, 0, tr("mm/S"), tr(""),
                                        tr(""),
                                        0, 0, 0x0031, operate));

    // 跳针最高主轴转速，范围 1--3000，单位r/min，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        120, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Jump maximum spindle speed"),// 跳针最高主轴转速
                                        1, 0, 3000, 1, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0032, operate));

    // 冲孔时动作允许 0, 不允许; 1, 允许;
    // bit0 吹气允许;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        39, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("Blowing allowed"),// 吹气允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0033, operate));

    ////////////////////////////////////动作设定
    //X偏移点
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        26, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X offset point"),//X偏移点
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    //Y偏移点
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        27, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y offset point"),//Y偏移点
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0002, operate));

    // 偏移点坐标有效标志; 0, 无效; 1, x有效; 2, y有效; 3, xy同时有效
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        25, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("offset point coordinates"),//偏移点坐标
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("invalid:0;x is valid:1;y is valid:2;xy are valid:3"),//无:0;有:1
                                        0, 0, 0x0003, operate));

    // 完成后停车位置选择, 0, 当前位置; 1，起点，2，定位点，3，上料点; 4，偏移点
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        24, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The stop position of the machine head after punching"),//冲孔完毕机头停止位置
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("current location:0;starting point:1;location point:2;feeding point:3;offset point:4"),
                                        0, 0, 0x0004, operate));

    // 主轴点动停车角度，单位 0.01度
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_ACTION,
                                        62, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle jog parking angle"),//主轴点动停车角度
                                        0, 0, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0004, operate));

    // 加油方式选择, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        20, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Refueling method selection"),// 加油方式选择
                                        0, 0, 3, 0, 0, tr(""), tr(""),//不加油:0;按工作时间间断加油:1;按工作针数间歇加油:2;持续加油:3
                                        tr("No:0; According to working hours:1; According to the number of working stitches:2; Persistent refueling:3"), 0, 0, 0x0120, operate));

    // 加油针数间隔, 范围 S32_MIN--S32_MAX，默认 10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        21, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling needles interval"),// 加油针数间隔
                                        10000, S32_MIN, S32_MAX, 10000, 0, tr("Needles"), tr(""),
                                        tr(""), 10000, 10000, 0x0120, operate));

    // 加油时间间隔, 范围 1--S32_MAX，默认 1  加油时间间隔, 单位小时, 加油方式为按工作时间加油时有用;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        22, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling time interval"),// 加油时间间隔
                                        1, 1, S32_MAX, 1, 0, tr("h"), tr(""),
                                        tr(""), 1, 1, 0x0120, operate));

    // 加油持续次数, 单位次
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        23, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling duration"),// 加油持续次数
                                        1, 1, S32_MAX, 1, 0, tr("bout"), tr(""),
                                        tr(""), 1, 1, 0x0120, operate));

    // 自动气框允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        102, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic air frame allowed"),// 自动气框允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0120, operate));

    // 气框自动关闭允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        102, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic closing of air frame allowed"),// 气框自动关闭允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0120, operate));

    // 气框自动打开允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        102, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic opening of air frame allowed"),// 气框自动打开允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0120, operate));

    // 气框自动关闭后扫码允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        102, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Code scanning allowed after automatic closing of air frame"),// 气框自动关闭后扫码允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0120, operate));

    // 自动气框闭合延时, 范围 0--5000，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        103, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Automatic air frame closing delay"),// 自动气框闭合延时
                                        0, 0, 5000, 0, 0, tr("ms"), tr(""),
                                        tr(""), 0, 0, 0x0120, operate));
}

void AutoPosPunchMachine::initOutCtrlList()
{
    m_allOutCtrlList.clear();

    QString enableStr = tr("Enable");   //使能
    QString disableStr = tr("Disable"); //失能
    QString jogPStr = tr("JogP"); //正转
    QString jogNStr = tr("JogN"); //反转
    QString zeroStr = tr("Zero"); //归零
    QString openStr = tr("Open"); //打开
    QString closeStr = tr("Close");//关闭
    QString upStr = tr("Up"); //上升
    QString downStr= tr("Down");//下降

    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("All punching spindle motor"),MT_LMA,// 所有主轴电机
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }
    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("No. 1 punching spindle motor"),MT_LPM,// 1号头冲孔主轴电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_TWOHEAD)//双头
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0002,tr("No. 2 punching spindle motor"),MT_LP2,// 2号头冲孔主轴电机
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }


    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("No. 3 punching spindle motor"),MT_LP3,// 3号头冲孔主轴电机
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("No. 4 punching spindle motor"),MT_LP4,// 4号头冲孔主轴电机
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("X motor"),MT_LX,// X电机

                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Y motor"),MT_LY,// Y电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("punching color changing motor"),MT_LPS,// 冲孔换色电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0005,tr("Punch rotate motor"),MT_LPR,// 冲孔旋转电机
                                                 enableStr,true,OUTCONTROL_MS_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_MS_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0008,tr("template positioning cylinder"),OT_FRAME,// 模板定位气缸
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000A,tr("Vacuum cleaner"),OT_CLEANER,// 吸尘器
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000B,tr("Safety barrier 1"),OT_SAFE_DOOR1,// 安全护栏1
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             upStr,true,OUTCONTROL_UP,-1,-1,
                                             downStr,true,OUTCONTROL_DOWN,-1,-1));
    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("Safety barrier 2"),OT_SAFE_DOOR2,// 安全护栏2
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             upStr,true,OUTCONTROL_UP,-1,-1,
                                             downStr,true,OUTCONTROL_DOWN,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("Punching refueling"),OT_PUNCH_OIL,// 冲孔加油
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("Headlamp"),OT_LIGHT,// 照明灯
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

}

void AutoPosPunchMachine::initShortCutList()
{
    m_allShortCutList.clear();

    m_allShortCutList.append(makeAShortCutItem(0,0x0001,tr("All To Zero"),"buttonAllToZero",FUN_ALLTOZERO));//全部归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0002,tr("Spindle Jog"),"buttonSpindleJog",FUN_PUNCHSPINDLEJOG));//主轴点动
    m_allShortCutList.append(makeAShortCutItem(0,0x0003,tr("Spindle Enable"),"buttonSpindleEnable",FUN_SPINDLEENABLE));//主轴使能
    m_allShortCutList.append(makeAShortCutItem(0,0x0004,tr("Spindle Disable"),"buttonSpindleDisable",FUN_SPINDLEDISABLE));//主轴失能
    m_allShortCutList.append(makeAShortCutItem(0,0x0005,tr("Spindle Test"),"buttonSpindleTest",FUN_SPINDLETEST));//主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x0006,tr("Set Offset"),"buttonSetOffsetPoint",FUN_SETOFFSETPOINT));//定偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x0007,tr("Go Offset"),"buttonBackOffsetPoint",FUN_BACKOFFSETPOINT));//回偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x000A,tr("Set Start"),"buttonSetAnchorPoint",FUN_SETSTARTPOINT));//定起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x000B,tr("Go Start"),"buttonBackAnchorPoint",FUN_BACKSTARTPOINT));//回起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x000C,tr("Go Work"),"buttonBackWorkPoint",FUN_BACKWORKPOINT));//回工作点
    m_allShortCutList.append(makeAShortCutItem(0,0x000D,tr("Check Frame"),"buttonBorderCheck",FUN_CHECKFRAME));//边框检查
    m_allShortCutList.append(makeAShortCutItem(0,0x000E,tr("Punch Change Tool"),"buttonManualChangeColor",FUN_PUNCHMANUALCHANGECOLOR));//手动换刀
    m_allShortCutList.append(makeAShortCutItem(0,0x000F,tr("Forward And Back"),"buttonForwardOrBack",FUN_FORWARDORBACK));//前进回退
    //m_allShortCutList.append(makeAShortCutItem(0,0x0010,tr("Reset"),"buttonProcessReset",FUN_PROCESSRESET));//流程复位
    m_allShortCutList.append(makeAShortCutItem(0,0x0011,tr("Single Punch"),"buttonSinglePunch",FUN_SINGLEPUNCH));//单次冲孔
    //m_allShortCutList.append(makeAShortCutItem(0,0x0012,tr("FrameZero"),"buttonFrameZero",FUN_FRAMEZERO));//框架归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0013,tr("To Right Up"),"buttonMoveToRightUp",FUN_MOVETORIGHTUP));//去右上角
    m_allShortCutList.append(makeAShortCutItem(0,0x0014,tr("To Right Down"),"buttonMoveToRightDown",FUN_MOVETORIGHTDOWN));//去右下角
    m_allShortCutList.append(makeAShortCutItem(0,0x0015,tr("To Left Up"),"buttonMoveToLeftUp",FUN_MOVETOLEFTUP));//去左上角
    m_allShortCutList.append(makeAShortCutItem(0,0x0016,tr("To Left Down"),"buttonMoveToLeftDown",FUN_MOVETOLEFTDOWN));//去左下角
    //m_allShortCutList.append(makeAShortCutItem(0,0x0017,tr("Scope Work"),"buttonSetWorkRange",FUN_SETWORKRANGE));//定工作范围
    m_allShortCutList.append(makeAShortCutItem(0,0x0018,tr("Head Stop Lower"),"buttonPunchStopLower",FUN_PUNCHSTOPLOWER));//冲头停下位
    m_allShortCutList.append(makeAShortCutItem(0,0x0019,tr("Draw Outline"),"buttonDrawOutline",FUN_DRAWOUTLINE));//画轮廓线
    m_allShortCutList.append(makeAShortCutItem(0,0x0020,tr("Oil Supply"),"buttonManualOil",FUN_OILSUPPLY));//冲孔连续供油

    if(g_emProductType == PRODUCT_PUNCH_ROTARY)//旋转冲
    {
        m_allShortCutList.append(makeAShortCutItem(0,0x0020,tr("Tool Debug"),"buttonSpindleEnable",FUN_ROTATECOMPENSATE));//旋转补偿   冲刀调试
        m_allShortCutList.append(makeAShortCutItem(0,0x0020,tr("Rotate To Zero"),"buttonRotToZero",FUN_PUNCH_ROT_TO_ZERO));//冲孔旋转去零位
    }
}

void AutoPosPunchMachine::initAssistList()
{
    m_allAssistList.clear();

    m_allAssistList.append(makeAAssistItem(0,0x0001,tr("Signal"),"buttonSensor",ASSIST_SENSOR));//传感器信号
    m_allAssistList.append(makeAAssistItem(0,0x0002,tr("Action"),"buttonControlAction",ASSIST_CONTROLACTION));//控制动作
    m_allAssistList.append(makeAAssistItem(0,0x0003,tr("HMIUpgrade"),"buttonHMIUpgrade",ASSIST_HMIUPGRADE));//界面升级
    m_allAssistList.append(makeAAssistItem(0,0x0004,tr("MCUpgrade"),"buttonMCUpgrade",ASSIST_MCUPGRADE));//主控升级
    m_allAssistList.append(makeAAssistItem(0,0x0006,tr("ParaImport"),"buttonParaImport",ASSIST_PARAIMPORT));//参数导入
    m_allAssistList.append(makeAAssistItem(0,0x0007,tr("ParaExport"),"buttonParaExport",ASSIST_PARAEXPORT));//参数导出
    m_allAssistList.append(makeAAssistItem(0,0x0008,tr("Software"),"buttonSoftwareSet",ASSIST_SOFTWARESET));//软件设置
    m_allAssistList.append(makeAAssistItem(0,0x0009,tr("Authorize"),"buttonSoftwareAuthor",ASSIST_AUTHORIZATION));//软件授权
    m_allAssistList.append(makeAAssistItem(0,0x000A,tr("Network"),"buttonNetworkManage",ASSIST_NETWORK));//网络管理

    s16 wifi = g_pSettings->readFromIniFile("HMI/wifi").toInt();//是否有wifi
    if(wifi == 1)
    {
        m_allAssistList.append(makeAAssistItem(0,0x000A,tr("WIFI"),"buttonSensor",ASSIST_WIFI));//WIFI管理
    }

    m_allAssistList.append(makeAAssistItem(0,0x000B,tr("NeedleSet"),"buttonNeedleSet",ASSIST_NEEDLESET));//针杆设置
    m_allAssistList.append(makeAAssistItem(0,0x000C,tr("Time"),"buttonTimeSet",ASSIST_TIMESET));//时间设置
    m_allAssistList.append(makeAAssistItem(0,0x000D,tr("Shortcut"),"buttonCommonFunction",ASSIST_SHORTCUTSET));//常用设置
    m_allAssistList.append(makeAAssistItem(0,0x000E,tr("Statistics"),"buttonProductStatistics",ASSIST_PRODUCTSTATICS));//生产统计
    m_allAssistList.append(makeAAssistItem(0,0x000F,tr("Version"),"buttonVersionInfo",ASSIST_MCVERSION));//版本信息
    m_allAssistList.append(makeAAssistItem(0,0x0014,tr("Root"),"buttonRoot",ASSIST_ROOT));//超级用户
    m_allAssistList.append(makeAAssistItem(0,0x0015,tr("errorjounal"),"buttonAgingTest",ASSIST_ERRORLOG));//超级用户
}

void AutoPosPunchMachine::initPatternSetList()
{
    m_allPatternSetList.clear();

    m_allPatternSetList.append(makeAPatternSetItem(0,0x0001,tr("Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT));//花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0002,tr("Para"),"buttonPatternPara",PATTERNSET_PATTERNPARA));//花样参数
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0003,tr("Color"),"buttonPatternColorOrder",PATTERNSET_PATTERNCOLOR));//花样色序
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0004,tr("Import"),"buttonPatternImport",PATTERNSET_PATTERNIMPORT));//花样导入
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0005,tr("Export"),"buttonPatternExport",PATTERNSET_PATTERNEXPORT));//花样导出
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0006,tr("Delete"),"buttonPatternDelete",PATTERNSET_PATTERNDELETE));//花样删除
}

void AutoPosPunchMachine::initParaSetList()
{
    m_allParaSetList.clear();

    m_allParaSetList.append(makeAParaSetItem(0,0x0001,tr("OperatPara"),"buttonOperatParas",PARASET_SETTING));//设置参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0002,tr("ActionSet"),"buttonActionParas",PARASET_ACTION));//动作参数   //动作设定
    m_allParaSetList.append(makeAParaSetItem(0,0x0003,tr("SpeedPara"),"buttonSpeedParas",PARASET_SPEED));//速度参数  //速度控制参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0004,tr("LimitPara"),"buttonPositionParas",PARASET_POSITION));// 位置参数  //限位参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0005,tr("MCPara"),"buttonSettingParas",PARASET_DETECT));//检测参数    //机器参数
}

//初始化传感器列表
void AutoPosPunchMachine::initSensorList()
{
    QList <SensorItem> sensorList;
    sensorList.append(makeASensorItem(0x0000, 0, tr("Start button")));//启动按钮
    sensorList.append(makeASensorItem(0x0001, 0, tr("stop button")));//停止按钮
    sensorList.append(makeASensorItem(0x0002, 0, tr("jog button")));//点动按钮
    sensorList.append(makeASensorItem(0x0003, 0, tr("open frame 1 button")));//开框1按钮
    sensorList.append(makeASensorItem(0x0003, 1, tr("open frame 2 button")));//开框2按钮
    sensorList.append(makeASensorItem(0x0008, 0, tr("Safety light curtain")));//安全光幕

    sensorList.append(makeASensorItem(0x0090, 0, tr("Spindle 1 zero position")));//主轴1零位
    sensorList.append(makeASensorItem(0x0090, 1, tr("Spindle 2 zero position")));//主轴2零位
    sensorList.append(makeASensorItem(0x0090, 2, tr("Spindle 3 zero position")));//主轴3零位
    sensorList.append(makeASensorItem(0x0090, 3, tr("Spindle 4 zero position")));//主轴4零位
    sensorList.append(makeASensorItem(0x003E, 0, tr("Punching 1 Rotation Zero")));//冲孔1旋转零位
    sensorList.append(makeASensorItem(0x003E, 1, tr("Punching 2 Rotation Zero")));//冲孔2旋转零位
    sensorList.append(makeASensorItem(0x003E, 2, tr("Punching 3 Rotation Zero")));//冲孔3旋转零位
    sensorList.append(makeASensorItem(0x003E, 3, tr("Punching 4 Rotation Zero")));//冲孔4旋转零位

    sensorList.append(makeASensorItem(0x0020, 0, tr("X1 zero position")));//X1零位
    sensorList.append(makeASensorItem(0x0020, 1, tr("Y1 zero position")));//Y1零位
    sensorList.append(makeASensorItem(0x0020, 2, tr("X2 zero position")));// X2零位
    sensorList.append(makeASensorItem(0x0020, 3, tr("Y2 zero position")));// Y2零位

    sensorList.append(makeASensorItem(0x0021, 0, tr("X1 slows down")));//X1降速
    sensorList.append(makeASensorItem(0x0021, 1, tr("Y1 deceleration")));//Y1降速
    sensorList.append(makeASensorItem(0x0021, 2, tr("X2 downshift")));//X2降速
    sensorList.append(makeASensorItem(0x0021, 3, tr("Y2 downshift")));// Y2降速

    sensorList.append(makeASensorItem(0x0022, 0, tr("1 limit-")));//X1限位-
    sensorList.append(makeASensorItem(0x0022, 1, tr("Y1 limit-")));// Y1限位-
    sensorList.append(makeASensorItem(0x0022, 2, tr("X2 limit -")));//X2限位-
    sensorList.append(makeASensorItem(0x0022, 3, tr("Y2 limit -")));//Y2限位-

    sensorList.append(makeASensorItem(0x0023, 0, tr("1 limit+")));//X1限位+
    sensorList.append(makeASensorItem(0x0023, 1, tr("Y1 limit+")));// Y1限位+
    sensorList.append(makeASensorItem(0x0023, 2, tr("X2 limit +")));//X2限位+
    sensorList.append(makeASensorItem(0x0023, 3, tr("Y2 limit +")));//Y2限位+
    sensorList.append(makeASensorItem(0x002C, 0, tr("Color change motor 1 zero position")));//换色电机1零位
    sensorList.append(makeASensorItem(0x002C, 1, tr("Color change motor 2 zero position")));//换色电机2零位
    sensorList.append(makeASensorItem(0x03FE, 0, tr("Punching color changing motor - zero position")));//冲孔换色电机-零位
    sensorList.append(makeASensorItem(0x03FE, 0, tr("Punching color changing motor - zero position")));//冲孔换色电机-零位
    sensorList.append(makeASensorItem(0x03FE, 0, tr("Punching Color Change Motor - Negative Limit")));//冲孔换色电机-负限位
    sensorList.append(makeASensorItem(0x03FE, 0, tr("Safety light curtain 1 input")));//安全光幕1输入
    sensorList.append(makeASensorItem(0x03FE, 0, tr("Safety light curtain 2 input")));//安全光幕2输入

    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        sensorList.append(makeASensorItem(0x0003, 2, tr("open frame 3 button")));//开框3按钮
        sensorList.append(makeASensorItem(0x0003, 3, tr("open frame 4 button")));//开框4按钮

        sensorList.append(makeASensorItem(0x0007, 0, tr("Air pressure protection input")));// 气压保护输入
    }
    else
    {
        sensorList.append(makeASensorItem(0x0007, 0, tr("Air pressure protection input")));// 气压保护输入
    }

    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        // xcy 0918 添加传感器
        sensorList.append(makeASensorItem(0x002C, 2, tr("Color change zero position 3")));//换色电机3-零位
        sensorList.append(makeASensorItem(0x002C, 3, tr("Color change zero position 4")));//换色电机4-零位
        sensorList.append(makeASensorItem(0x002C, 4, tr("X3 zero position")));// X3零位
        sensorList.append(makeASensorItem(0x002C, 5, tr("Y3 zero position")));// Y3零位
        sensorList.append(makeASensorItem(0x002C, 6, tr("X4 zero position")));// X4零位
        sensorList.append(makeASensorItem(0x002C, 7, tr("Y4 zero position")));// Y4零位

        sensorList.append(makeASensorItem(0x002E, 4, tr("X3 limit -")));//X3限位-
        sensorList.append(makeASensorItem(0x002E, 5, tr("Y3 limit -")));//Y3限位-
        sensorList.append(makeASensorItem(0x002E, 6, tr("X4 limit -")));//X4限位-
        sensorList.append(makeASensorItem(0x002E, 7, tr("Y4 limit -")));//Y4限位-

        sensorList.append(makeASensorItem(0x002F, 4, tr("X3 limit +")));//X3限位+
        sensorList.append(makeASensorItem(0x002F, 5, tr("Y3 limit +")));//Y3限位+
        sensorList.append(makeASensorItem(0x002F, 6, tr("X4 limit +")));//X4限位+
        sensorList.append(makeASensorItem(0x002F, 7, tr("Y4 limit +")));//Y4限位+

        sensorList.append(makeASensorItem(0x00A0, 0, tr("Spindle position detection 1")));//冲孔主轴零位
        sensorList.append(makeASensorItem(0x00A0, 1, tr("Spindle position detection 2")));//冲孔主轴零位
        sensorList.append(makeASensorItem(0x00A0, 2, tr("Spindle position detection 3")));//冲孔主轴零位
        sensorList.append(makeASensorItem(0x00A0, 3, tr("Spindle position detection 4")));//冲孔主轴零位
    }

    //将机型所需的传感器列表替换到传感器整体列表中
    for(int i = 0; i < sensorList.size(); i++)
    {
        int byteaddr = sensorList[i].m_byte_offset;
        int bitaddr = sensorList[i].m_bit_offset;
        QString str = sensorList[i].m_name;
        int type = sensorList[i].m_type;

        int idx = byteaddr*8+bitaddr;
        if(idx < m_allSensorList.size())
        {
            m_allSensorList[idx].m_name = str;
            m_allSensorList[idx].m_type = type;
        }
    }
}

//初始化错误代码和状态列表
void AutoPosPunchMachine::initErrorCodeAndStateList()
{
    m_allErrorCodeAndStateList.clear();

    //等于冲孔机并为4头
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS && g_emProductType == PRODUCT_PUNCH_FOURHEAD)
    {
        m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_NOT_ZERO, tr("Punching spindle is not at zero position")));// 冲孔主轴不在零位
    }
    //等于冲孔机并为4头end
    else
    {
        m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_NOT_ZERO, tr("Punching 1 spindle is not at zero position")));// 冲孔1主轴不在零位
    }

    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_CLR_BLK, tr("Vacuum cleaner clogged")));// 吸尘器阻塞
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_CLR_FULL, tr("Vacuum cleaner full")));// 吸尘器满料
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_OIL_AIR, tr("Abnormal oil pump pressure")));// 油泵压力异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH2_NOT_ZERO, tr("Punching 2 spindle is not at zero position")));// 冲孔2主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_SWND_TIMOUT, tr("Punching color change timeout")));// 冲孔换色超时
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_ND_ERR, tr("Punching needle position error")));// 冲孔针位错误
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH3_NOT_ZERO, tr("Punching 3 spindle is not at zero position")));// 冲孔3主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH4_NOT_ZERO, tr("Punching 4 spindle is not at zero position")));// 冲孔4主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_NOT_BACK, tr("Breathing valve punching cylinder is not high")));// 呼吸阀冲孔气缸不在高位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_CMK_BTP, tr("Abnormality on the punching hole of the breathing valve")));// 呼吸阀冲孔上异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_CMK_BBP, tr("Abnormal under the breathing valve punching")));// 呼吸阀冲孔下异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_CMK_BPB, tr("Abnormal expansion and contraction of the stopper under the punching valve of the breathing valve")));// 呼吸阀冲孔下挡块伸缩异常
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH2_NOT_ZERO, tr("Punching 2 spindle is not at zero position")));// 冲孔2主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH2_NOT_ZERO, tr("Punching 2 spindle is not at zero position")));// 冲孔2主轴不在零位
}

