﻿#ifndef NEEDLEBARSETWIDGET_H
#define NEEDLEBARSETWIDGET_H

#include <QWidget>
#include <QPushButton>
#include <QDir>
#include <QFile>
#include "numerinputdialog.h"
#include "mybutton.h"
#include "setcontrolstyle.h"
#include <QMouseEvent>
#include <QDateTime>
#include "mctype/mainwidgetfunction.h"

enum SET_TYPE {
    SET_TYPE_NEEDLE_EMB = 1,  //绣花针杆设置
    SET_TYPE_NEEDLE_PUNCH,    //冲孔针杆设置
    SET_TYPE_NEEDLE_SEW       //缝纫针杆设置
};

namespace Ui {
class NeedleBarSetWidget;
}

class NeedleBarSetWidget : public QWidget
{
    Q_OBJECT

public:
    explicit NeedleBarSetWidget(QWidget *parent = 0);
    ~NeedleBarSetWidget();

private:
    Ui::NeedleBarSetWidget *ui;
    QList<QPushButton*> m_embNeedleBtnList;
    QList<QPushButton*> m_colorBtnList;
    QPushButton *m_pEmbNeedleBtn;
    QPushButton *m_pColorBtn;

    QRgb *m_pColorBuf;
    QString m_buttonStyle1;
    QString m_buttonStyle2;

    QString m_configFile;
    s16 m_setType;  //针杆设置类型

private:
    void initWidget();
    void initControl();//初始化窗体控件，包括位置、尺寸、样式
    void initResolution1910();//初始化窗体控件为1920x1080分辨率
    void initResolution1006();
    void initControlStyle();//初始化窗体控件样式
    void refreshNeedleColorShow();//刷新针杆数量及颜色

public:
    void setTypeLogo(QString tStyle);//设置类型图标
    void setMainTitle(QString str);//设置主title
    void setSubTitle(QString str);//设置副title
    void initNeedleBar();//初始化针杆
    void refreshTypeBtnShow();//刷新右上方按钮的显示,包括选中状态

private slots:
    void embNeedleBtnClick();
    void colorBtnClick();
    void on_buttonEmbNeedleNum_clicked();
    void on_buttonOk_clicked();
    void on_buttonEmbSet_clicked();
    void on_buttonPunchSet_clicked();
    void on_buttonSewSet_clicked();

signals:
    void siChangeNeedleColor(int idx,int colorIdx);
};

#endif // NEEDLEBARSETWIDGET_H
