#include "templatesewmachine.h"
//模板缝纫机
TemplateSewMachine::TemplateSewMachine()
{
    //添加各种参数到列表中
    initRootParasList();
    initRootHMIConfigurationList(m_allParasList);//超级用户界面配置
    initRootIOTConfigurationList(m_allParasList); //超级用户物联网配置
    initPatternsParasList();
    initSoftwareParasList(m_allParasList);
    initTimeParasList(m_allParasList);
    initPunchEmbSewCommonFunParasList(m_allParasList);
    initMcParasList();
    initWkParasList();

    //初始化控制动作列表
    initOutCtrlList();

    //初始化快捷功能列表
    initShortCutList();

    //初始化辅助功能列表
    initAssistList();

    //初始化花样设置功能列表
    initPatternSetList();

    //初始化参数设定列表
    initParaSetList();

    //初始化传感器列表
    initSensorList();

    //初始化错误代码和状态列表
    initErrorCodeAndStateList();

    //初始化调试功能列表
    initDebugFunList();
}

TemplateSewMachine::~TemplateSewMachine()
{

}

//超级用户参数(包括机器参数、工作参数)
void TemplateSewMachine::initRootParasList()
{
    //超级用户参数---------------------------
    //超级用户参数-界面配置；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_HMICONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("HMI Configuration"),//界面配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0000 , factory));

    //超级用户参数-删除config.ini配置文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETEINI, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete configure file"),//删除配置文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 ,  root));

    //超级用户参数-重置花样配置-删除花样fcg文件影响fileid的数据;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_CLEARPATTERNFCG_FILEID, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete pattern configuration"),//删除花样配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001, factory));

    //超级用户参数-导入csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IMPORTCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Import CSV file"),//导入csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-删除csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETECSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete CSV file"),//删除csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-重置安装调试进度；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_RESETCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Reset CSV file"),//重置安装调试进度
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-机器参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                    PARA_TYPE_ROOT,
                                    0 ,
                                    ROOT_MACHINEPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                    tr("Machine parameters"),//机器参数
                                    0, 0, 0, 0, 0, tr(""), tr(""),
                                    tr(""),
                                    0, 0, 0x0002, factory));

    //超级用户参数-工作参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                    PARA_TYPE_ROOT,
                                    0 ,
                                    ROOT_WORKPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                    tr("Work parameters"),//工作参数
                                    0, 0, 0, 0, 0, tr(""), tr(""),
                                    tr(""),
                                    0, 0, 0x0003, factory));

    //超级用户参数-物联网配置;
    m_allParasList.append(makeAParaItem(0,
                                       PARA_TYPE_ROOT,
                                       0 ,
                                       ROOT_IOTCONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                       tr("InternetofThings  configuration"),//物联网配置
                                       0, 0, 0, 0, 0, tr(""), tr(""),
                                       tr(""),
                                       0, 0, 0x000D, factory));
}

//花样参数
void TemplateSewMachine::initPatternsParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    //花样参数-花样设置参数-定位点x；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ANCHORX, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("AnchorX"),//定位点X
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0001, operate));

    //花样参数-花样设置参数-定位点y；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ANCHORY, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("AnchorY"),//定位点Y
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0002, operate));

    //花样参数-花样设置参数-起始点x；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_STARTX, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startX"),//起始点X
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-起始点y；范围-1000000--1000000，单位0.01mm，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_STARTY, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("startrY"),//起始点Y
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0004, operate));

    //花样参数-花样设置参数-连续动框补偿；单位：无，范围0-1000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_CONTINURUNCOMP, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Continuous motion frame compensation"),//连续动框补偿
                                        0, 0, 1000, 0, 0, tr(""), tr(""),//
                                        tr(""), 0, 0,0x0005, operate));

    //花样参数-花样设置参数-针尖补偿；单位：mm，范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_NEEDLETIPCOMP, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Needle tip compensation"),//针尖补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),//
                                        tr(""), 0, 0,0x0006, operate));

    //花样参数-花样设置参数-需要分割的针步长度；单位：mm，范围3-20，默认7
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_SPLITSTITCHLENGTH, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of the stitch that needs to be split"),//需要分割的针步长度
                                        700, 300, 2000, 700, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0007, operate));

    //花样参数-花样设置参数-翻转式样；单位：无 ，范围0-7，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATESTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flip style"),//翻转式样
                                        0, 0, 7, 0, 0, tr(""), tr(""),
                                        tr("normalP:0;nRight90P:1;nRight180P:2;nRight270P:3;mirrorP:4;mRight90P:5;mRight180P:6;mRight270P:7"),
                                        0, 0, 0x0008, operate));

    //花样参数-花样设置参数-水平翻转样式；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_HORIZONTALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Horizontal flip style"),//水平翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0009, operate));

    //花样参数-花样设置参数-垂直翻转式样；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_VERTICALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("vertical flip style"),//垂直翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x000A, operate));

    //花样参数-花样设置参数-旋转角度；单位：° ，范围0-90，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATEANGLE, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation angle"),//旋转角度
                                        0, 0, 90, 0, 0, cod->toUnicode("°"), tr(""),//度
                                        tr(""), 0, 0,0x000B, operate));
    //花样参数---------------------------
}

//主控机器参数
void TemplateSewMachine::initMcParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 冲孔机头个数，无单位， 范围1-32，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of  heads"),// 机头个数
                                        1, 1, 32, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0000, factory));

    // 每头机针个数，无单位， 范围1-32，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        3, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("sewing needles per head"),// 每头机针个数
                                        1, 1, 32, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0000, factory));

    // 平绣针数，无单位， 范围1-32，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        4, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("emb needles per head"),// 平绣针数
                                        1, 1, 32, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0000, factory));

    // 冲孔针数，无单位， 范围1-32，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        5, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("punch needles per head"),// 冲孔针数
                                        1, 1, 32, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0000, factory));

    // X轴配置，无单位， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis configuration"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0002, factory));

    // X轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis motor drive selection"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x0003, factory));

    // X轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis coordinate system selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        1, 1, 0x0004, factory));

    // X轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis moving object selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        1, 1, 0x0005, factory));

    // X轴零位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis zero sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0006, factory));

    // X轴降速传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis speed reduction sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0007, factory));

    // X轴正限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis positive limit sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0008, factory));

    // X轴负限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis negative limit sensor selection"),//X轴负限位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0009, factory));

    // X轴零位方向选择， 范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis zero direction selection"),//X轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x0010, factory));

    // X轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 10, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis sensor function selection"),//X轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x0011, factory));

    // Y轴配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis configuration"),//Y轴配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0012, factory));

    // Y轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis motor drive selection"),//Y轴电机驱动选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x0013, factory));

    // Y轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis coordinate system selection"),//Y轴坐标系统选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        1, 1, 0x0014, factory));

    // Y轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis moving object selection"),//Y轴移动对象选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        1, 1, 0x0015, factory));

    // Y轴零位传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis zero sensor selection"),//Y轴零位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0016, factory));

    // Y轴降速传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis speed reduction sensor selection"),//Y轴降速传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0017, factory));

    // Y轴正限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis positive limit sensor selection"),//Y轴正限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0020, factory));

    // Y轴负限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis negative limit sensor selection"),//Y轴负限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0021, factory));

    //Y轴零位方向选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis zero direction selection"),//Y轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x0022, factory));

    //Y轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 10, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis sensor function selection"),//Y轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x0023, factory));

    // X2轴配置，无单位， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis configuration"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0024, factory));

    // X2轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis motor drive selection"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x0024, factory));

    // X2轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis coordinate system selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        1, 1, 0x0025, factory));

    // X2轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis moving object selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        1, 1, 0x0026, factory));

    // X2轴零位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis zero sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0027, factory));

    // X2轴降速传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis speed reduction sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0028, factory));

    // X2轴正限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis positive limit sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0029, factory));

    // X2轴负限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis negative limit sensor selection"),//X轴负限位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x002A, factory));

    // X2轴零位方向选择， 范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis zero direction selection"),//X轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x002B, factory));

    // X2轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        12, 10, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X2 axis sensor function selection"),//X轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x002C, factory));

    // Y2轴配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis configuration"),//Y轴配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x002D, factory));

    // Y2轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis motor drive selection"),//Y轴电机驱动选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x002E, factory));

    // Y2轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis coordinate system selection"),//Y轴坐标系统选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        1, 1, 0x002F, factory));

    // Y2轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis moving object selection"),//Y轴移动对象选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        1, 1, 0x0031, factory));

    // Y2轴零位传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis zero sensor selection"),//Y轴零位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0032, factory));

    // Y2轴降速传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis speed reduction sensor selection"),//Y轴降速传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0033, factory));

    // Y2轴正限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis positive limit sensor selection"),//Y轴正限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0034, factory));

    // Y2轴负限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis negative limit sensor selection"),//Y轴负限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0035, factory));

    //Y2轴零位方向选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis zero direction selection"),//Y轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x0036, factory));

    //Y2轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        13, 10, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y2 axis sensor function selection"),//Y轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x0037, factory));

    //缝纫主轴配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        14, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing spindle configuration"),//缝纫主轴配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0038, factory));

    //针梭配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        14, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle shuttle configuration"),//针梭配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Needle shuttle:0;Needle shuttle separation:1"),//针穿梭:0;针梭分离:1
                                        1, 1, 0x0039, factory));

    //升降电机配置，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        15, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lift motor configuration"),//升降电机配置
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x003A, factory));

    //压脚电机配置，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        16, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Presser foot motor configuration"),//压脚电机配置
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x003B, factory));

    //旋转电机配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        17, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Rotating motor configuration"),//旋转电机配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x003C, factory));

    //旋转电机坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        17, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Rotary motor coordinate system"),//旋转电机坐标系统选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Single motor: 0 ; Double motor: 1"),//单电机:0;双电机:1
                                        1, 1, 0x003D, factory));

    //旋转电机坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        17, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Rotary motor coordinate system"),//旋转电机坐标系统选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("The coordinate system is positive: 0 ; Coordinate system is reverse: 1"),//坐标系为正:0;坐标系为负:1
                                        1, 1, 0x003E, factory));

    //旋转电机转动对象 选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        17, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Rotary motor coordinate system"),//旋转电机转动对象选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Machine head: 0 ; box: 1"),//机头:0;框:1
                                        0, 0, 0x003F, factory));

    //旋转限制 选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        17, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Rotation limit"),//旋转限制 选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Unlimited: 0 ; limited: 1"),//有限制:0;无限制:1
                                        1, 1, 0x0040, factory));

    //下剪刀驱动装置选择，范围0-4，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        18, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lower scissors drive selection"),//下剪刀驱动装置选择
                                        1, 0, 4, 1, 0, tr(""), tr(""),
                                        tr("No lower trimming device:0;Cylinder:1;AC motor:2;Stepper motor:3;Electromagnet:4"),//无下剪线装置:0;气缸:1;交流电机:2;步进电机:3;电磁铁:4
                                        1, 1, 0x0041, factory));

    //下剪线模式选择，范围0-3，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        19, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lower trimming mode selection"),//下剪线模式选择
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Static trimming:0;Dynamic trimming:1;Cam trimming:2;Cam respectively trimming:3"),//静态剪线:0;动态剪线:1;凸轮剪线:2;凸轮分别剪线:3
                                        0, 0, 0x0042, factory));

    //上剪刀驱动装置选择， 范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        20, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Upper scissors drive selection"),//上剪刀驱动装置选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No Upper trimming Device:0;Cylinder:1"),//无上剪线装置:0;气缸:1
                                        0, 0, 0x0043, factory));

    //面线断线检测装置选择，范围0-2，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        21, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Upper thread break detection device selection"),//面线断线检测装置选择
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("No:0;Pick wire spring:1;Electronic isolation:2"),//无:0;拣选钢丝弹簧:1;电子隔离开关:2
                                        1, 1, 0x0044, factory));

    //底线断线检测装置选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        22, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Bottom line break detection device selection"),//底线断线检测装置选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No device: 0 ;  Grating wheel: 1 ; Magnetic encoder: 2;Immediate alarm by length:3"),//无:0;光栅轮:1;磁编码器:2;按长度即时报警:3
                                        0, 0, 0x0045, factory));

    //断线检测模式选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        23, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Wire break detection mode selection"),//断线检测模式选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Direct detection:0;EXBboard detection:1"),//直接检测:0;外围板检测:1
                                        0, 0, 0x0046, factory));

    //勾面线装置选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        24, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Hook line device selection"),//勾面线装置选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No hook line device:0;Cylinder:1;Electromagnet:2"),//无勾线装置:0;气缸:1;电磁铁:2
                                        0, 0, 0x0047, factory));

    //松面线装置选择，范围0-2，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        25, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Loose line device selection"),//松面线装置选择
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("No loose wire device:0;Cylinder:1;Electromagnet:2"),//无松线装置:0;气缸:1个;电磁铁:2
                                        1, 1, 0x0048, factory));

    //拉面线装置选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        26, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Ramen line device selection"),//拉面线装置选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No ramen line device:0;Cylinder:1;Electromagnet:2"),//无拉面线装置:0;气缸:1;电磁铁:2
                                        0, 0, 0x0049, factory));

    //扣底线装置选择，范围0-2，默认2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        27, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Bottom line device selection"),//扣底线装置选择
                                        2, 0, 2, 2, 0, tr(""), tr(""),
                                        tr("No bottom line device:0;Cylinder:1;Electromagnet:2"),//无底线装置:0;气缸:1;电磁铁:2
                                        2, 2, 0x004A, factory));

    //第二松面线选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        28, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Second loose line device selection"),//第二松面线选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No loose wire device: 0 ;  cylinder: 1 ; Electromagnet: 2"),//无松线装置:0;气缸:1;电磁铁:2
                                        0, 0, 0x004B, factory));

    //模板识别装置，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        29, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Template recognition device"),//模板识别装置
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No identification device: 0 ; Bar code: 1 ; Coding hole: 2"),//无识别装置:0;条形码:1;编码孔:2
                                        0, 0, 0x004C, factory));

    //旋梭面对方向，范围0-3，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        30, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The hook faces the direction"),//旋梭面对方向
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Forward:0;Left:1;Right:2;Up:3"),//正:0;左:1;右:2;下:3
                                        0, 0, 0x004D, factory));

    //模板检测装置，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        31, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Template detecting device"),//旋梭面对方向
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No detection device: 0 ;  Detect: 1"),//无检测装置:0;有检测装置:1
                                        0, 0, 0x004E, factory));

    // X框传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        50, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X box sensor coordinates"),//X框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 0, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x004F, factory));

    // Y框传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        51, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y box sensor coordinates"),//Y框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 0, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0050, factory));

    //主轴停车传感器角度, 范围0-36000，默认4500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        52, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle parking sensor angle"),//主轴停车传感器角度
                                        4500, 0, 36000, 4500, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0051, factory));

//    //升降传感器坐标, 范围S32_MIN--S32_MAX, 默认0
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_POSITION,
//                                        53, 4, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Lift sensor coordinates"),//升降传感器坐标
//                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x0052, factory));

    //压脚传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        54, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot sensor coordinates"),//压脚传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0053, factory));

    //旋转传感器角度, 范围-36000-36000, 默认18000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        55, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation sensor angle"),//旋转传感器角度
                                        18000, -36000, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0054, factory));

    //主轴勾线传感器角度, 范围0-36000，默认20200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        56, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle hook line sensor angle unit"),//主轴勾线传感器角度
                                        20200, 0, 36000, 20200, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0055, repair));

    //冲头停车角度, 范围0-36000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        57, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punch parking angle"),//冲头停车角度
                                        0, 0, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0056, repair));

    //裁刀停车角度, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        58, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Knife parking angle"),//裁刀停车角度
                                        0, S32_MIN, S32_MAX, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0057, repair));

    //X2框传感器坐标, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        59, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X2 box sensor coordinates"),//X2框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0057, factory));

    //Y2框传感器坐标, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        60, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y2 box sensor coordinates"),//Y2框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0057, factory));

    //拉料电机传感器坐标, 范围S32_MIN--S32_MAX，默认0
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_POSITION,
//                                        61, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Pull motor sensor coordinates"),//拉料电机传感器坐标
//                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x0058, factory));

    //主轴点动停车角度, 范围-36000-36000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        62, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle jog parking angle"),//主轴点动停车角度
                                        0, -36000, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x005B, repair));

    //平绣主轴停车角度, 范围0-36000，默认10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        63, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery spindle parking angle"),//平绣主轴停车角度
                                        10000, 0, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x005C, repair));

    //X可移动区域负边界, 范围S32_MIN--S32_MAX, 默认6800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        70, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area negative boundary"),//X可移动区域负边界
                                        6800, S32_MIN, S32_MAX, 6800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x005D, factory));

    //X可移动区域正边界, 范围S32_MIN--S32_MAX，默认207500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        71, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area positive boundary"),//X可移动区域正边界
                                        207500, S32_MIN, S32_MAX, 207500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x005E, factory));

    //Y可移动区域负边界, 范围S32_MIN--S32_MAX，默认4500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area negative boundary"),//Y可移动区域负边界
                                        4500, S32_MIN, S32_MAX, 4500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x005F, factory));

    //Y可移动区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area positive boundary"),//Y可移动区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0060, factory));

//    //机头升降可移动上边界, 范围S32_MIN--S32_MAX，默认0
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_POSITION,
//                                        74, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Head lift can move the upper boundary"),//机头升降可移动上边界
//                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x0061, factory));

//    //机头升降可移动下边界, 范围S32_MIN--S32_MAX，默认0
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_POSITION,
//                                        75, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Head lift can move the lower boundary"),//机头升降可移动下边界
//                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x0062, factory));

    //压脚升降可移动上边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        76, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lift can move the upper boundary"),//压脚升降可移动上边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0063, factory));

    //压脚升降可移动下边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        77, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lift can move the lower boundary"),//压脚升降可移动下边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0064, factory));

    //电机压脚脉冲当量分子, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        78, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Motor presser pulse equivalent molecule"),//电机压脚脉冲当量分子
                                        0, S32_MIN, S32_MAX, 0, 2, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0065, factory));

    //电机压脚脉冲当量分母, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        79, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Motor presser pulse equivalent denominator"),//电机压脚脉冲当量分母
                                        0, S32_MIN, S32_MAX, 0, 2, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0066, factory));

    //旋转范围正向限制角度, 范围S32_MIN--S32_MAX，默认49000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        80, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation range positive limit angle"),//旋转范围正向限制角度
                                        0, S32_MIN, S32_MAX, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0067, factory));

    //旋转范围反向限制角度, 范围S32_MIN--S32_MAX，默认-31000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        81, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation range negative limit angle"),//旋转范围正向限制角度
                                        -31000, S32_MIN, S32_MAX, -31000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0068, factory));

    //冲孔机头偏移X, 范围S32_MIN--S32_MAX，默认-20630
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        82, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching head offset X"),//冲孔机头偏移X
                                        -20630, S32_MIN, S32_MAX, -20630, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0069, factory));

    //冲孔机头偏移Y, 范围S32_MIN--S32_MAX，默认-30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        83, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching head offset Y"),//冲孔机头偏移Y
                                        -30, S32_MIN, S32_MAX, -30, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006A, factory));

    //x可缝纫区域负边界, 范围S32_MIN--S32_MAX，默认6800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        84, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Sewing area Negative boundary"),//x可缝纫区域负边界
                                        6800, S32_MIN, S32_MAX, 6800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006B, factory));

    //x可缝纫区域正边界, 范围S32_MIN--S32_MAX，默认128800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        85, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Sewing area Positive margin"),//x可缝纫区域正边界
                                        128800, S32_MIN, S32_MAX, 128800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006C, factory));

    //y可缝纫区域负边界, 范围S32_MIN--S32_MAX，默认20300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        86, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Sewing area Negative boundary"),//y可缝纫区域负边界
                                        20300, S32_MIN, S32_MAX, 20300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006D, factory));

    //y可缝纫区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        87, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Sewing area Positive margin"),//y可缝纫区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006E, factory));

    //x可冲孔区域负边界, 范围S32_MIN--S32_MAX，默认56500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        88, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Can be perforated region Negative boundary"),//x可冲孔区域负边界
                                        56500, S32_MIN, S32_MAX, 56500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x006F, factory));

    //x可冲孔区域正边界, 范围S32_MIN--S32_MAX，默认178500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        89, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Can be perforated region Positive margin"),//x可冲孔区域正边界
                                        178500, S32_MIN, S32_MAX, 178500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0070, factory));

    //y可冲孔区域负边界, 范围S32_MIN--S32_MAX，默认20300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        90, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Can be perforated region Negative boundary"),//y可冲孔区域负边界
                                        20300, S32_MIN, S32_MAX, 20300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0071, factory));

    //y可冲孔区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        91, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Can be perforated region Positive margin"),//y可冲孔区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0072, factory));

    //缝纫右机头偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        92, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing right head offset X"),//缝纫右机头偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0073, factory));

    //缝纫右机头偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        93, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing right head offset Y"),//缝纫右机头偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0074, factory));

    //切刀机头偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        94, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Cutter head offset X"),//切刀机头偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0075, factory));

    //切刀机头偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        95, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Cutter head offset Y"),//切刀机头偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0075, factory));

    //x可裁切区域负边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        96, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("x can crop the negative boundary of the area"),//x可裁切区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0076, factory));

    //x可裁切区域正边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        97, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("x can crop the positive boundary of the area"),//x可裁切区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0077, factory));

    //y可裁切区域负边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        98, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("y can crop the negative boundary of the area"),//x可裁切区域负边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0078, factory));

    //y可裁切区域正边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        99, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("y can crop the positive boundary of the area"),//x可裁切区域正边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0079, factory));

    //xy启动停止速度, 范围1-100，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        100, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY start stop speed"),//xy启动停止速度
                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x007B, factory));

    //xy归零运行速度, 范围1-100，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        101, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY zero running speed"),//xy归零运行速度
                                        100, 1, 100, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x007C, factory));

    //xy空走运行速度, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        102, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY Idling speed"),//xy空走运行速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x007D, factory));

    //xy行走加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        103, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY walking acceleration"),//xy行走加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x007E, factory));

    //xy刹车加速度, 范围1-10000，默认10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        104, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY brake acceleration"),//xy刹车加速度
                                        10000, 1, 10000, 10000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x007F, factory));

    //xy手动移动速度1, 范围1-1000，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        105, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 1"),//xy手动移动速度1
                                        10, 1, 1000, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0080, factory));

    //xy手动移动速度2, 范围1-1000，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        106, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 2"),//xy手动移动速度2
                                        100, 1, 1000, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0081, factory));

    //xy手动移动速度3, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 3"),//xy手动移动速度3
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0082, factory));

    //xy最高移动速度, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        108, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY maximum moving speed"),//xy最高移动速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0083, factory));

    //主轴启动停止转速, 范围1-300，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        109, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle start stop speed"),//主轴启动停止转速
                                        100, 1, 300, 100, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0084, factory));

    //主轴归零转速, 范围1-3000，默认120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle zero return speed"),//主轴归零转速
                                        120, 1, 3000, 120, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0085, factory));

    //主轴运转转速, 范围1-3000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        111, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle running speed"),//主轴运转转速
                                        300, 1, 3000, 300, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0086, factory));

    //主轴运转加速度, 范围1-100，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        112, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle running acceleration"),//主轴运转加速度
                                        50, 1, 100, 50, 0, tr("r/ss"), tr(""),
                                        tr(""),
                                        0, 0, 0x0087, factory));

    //主轴刹车加速度, 范围1-100，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        113, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle brakes acceleration"),//主轴刹车加速度
                                        100, 1, 100, 100, 0, tr("r/ss"), tr(""),
                                        tr(""),
                                        0, 0, 0x0088, factory));

    //主轴缝纫最高转速, 范围1-3000，默认1200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        114, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("sewing maximum speed"),//主轴缝纫最高转速
                                        1200, 1, 3000, 1200, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        0, 0, 0x0089, factory));

    //机头升降起停速度, 范围1-250，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        115, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift start end speed"),//机头升降起停速度
                                        10, 1, 250, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x008A, factory));

    //机头升降归零速度, 范围1-250，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        116, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift and zero speed"),//机头升降归零速度
                                        50, 1, 250, 50, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x008B, factory));

    //机头升降行走速度, 范围1-250，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        117, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift walk speed"),//机头升降行走速度
                                        200, 1, 250, 200, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x008C, factory));

    //机头升降行走加速度, 范围1-10000，默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        118, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift acceleration"),//机头升降行走加速度
                                        500, 1, 10000, 500, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x008D, factory));

    //机头升降刹车加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        119, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head movements brake acceleration"),//机头升降刹车加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x008E, factory));

    //压脚升降起停速度, 范围1-100，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        120, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift start end speed"),//压脚升降起停速度
                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x008F, factory));

    //压脚升降归零速度, 范围1-100，默认30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        121, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lift zero speed"),//压脚升降归零速度
                                        30, 1, 100, 30, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0090, factory));

    //压脚升降行走速度, 范围1-100，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        122, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lifting speed"),//压脚升降行走速度
                                        100, 1, 100, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0091, factory));

    //压脚升降行走加速度, 范围1-10000，默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        123, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lifting acceleration"),//压脚升降行走加速度
                                        500, 1, 10000, 500, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x0092, factory));

    //压脚升降刹车加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        124, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot lift brake acceleration"),//压脚升降刹车加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x0093, factory));

    //机头旋转启动停止速度, 范围1-720，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        125, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation start stop speed"),//机头旋转启动停止速度
                                        10, 1, 720, 10, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0094, factory));

    //机头旋转归零速度, 范围1-720，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        126, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation zero return speed"),//机头旋转归零速度
                                        50, 1, 720, 50, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0095, factory));

    //机头旋转运转速度, 范围1-720，默认360
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        127, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation speed"),//机头旋转运转速度
                                        360, 1, 720, 360, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0096, factory));

    //机头旋转运动加速度, 范围1-10000，默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        128, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation acceleration"),//机头旋转运动加速度
                                        500, 1, 10000, 500, 0, tr("deg/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x0097, factory));

    //机头旋转刹车加速度, 范围1-10000，默认5000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        129, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation brake acceleration"),//机头旋转刹车加速度
                                        5000, 1, 10000, 5000, 0, tr("deg/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x0098, factory));

    //机头旋转最高速度, 范围1-720，默认720
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        130, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head rotation maximum speed"),//机头旋转最高速度
                                        720, 1, 720, 720, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x0099, factory));

//    //最小画笔绘画速度, 范围1-100，默认10
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_SPEED,
//                                        131, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Minimum brush painting speed"),//最小画笔绘画速度
//                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x009A, factory));

//    //最大画笔绘画速度, 范围1-1200，默认1000
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_SPEED,
//                                        132, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Maximum brush painting speed"),//最大画笔绘画速度
//                                        1000, 1, 1200, 1000, 0, tr("mm/s"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x009B, factory));

//    //画笔绘画加速度, 范围1-4000，默认500
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_SPEED,
//                                        133, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Brush painting acceleration"),//画笔绘画加速度
//                                        500, 1, 4000, 500, 0, tr("mm/s2"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x009C, factory));

//    //画笔绘画降速最小偏差角度, 范围1-18000，默认3000
//    m_allParasList.append(makeAParaItem(0,
//                                        PARA_TYPE_MACH,
//                                        MC_SORT_ACTION,
//                                        134, 0, 0, PARA_VALUE_TYPE_INT,
//                                        tr("Brush painting slowdown minimum deviation angle"),//画笔绘画降速最小偏差角度
//                                        3000, 1, 18000, 3000, 0, cod->toUnicode("°"), tr(""),
//                                        tr(""),
//                                        0, 0, 0x009D, factory));

    //左上料点x, 范围S32_MIN-S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        135, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Left loading point X"),//左上料点x
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x009E, factory));

    //左上料点y, 范围S32_MIN-S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        136, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Left loading point Y"),//左上料点y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x009F, factory));

    //右上料点x, 范围S32_MIN-S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        137, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Right loading point X"),//右上料点x
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A0, factory));

    //右上料点y, 范围S32_MIN-S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        138, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Right loading point Y"),//右上料点y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A1, factory));

    //模板框宽度, 范围S32_MIN-S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        139, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template box width"),//模板框宽度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A2, factory));

    //模板框启停速度, 范围1-100，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        140, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template frame start and stop speed"),//模板框启停速度
                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A3, factory));

    //模板框行走速度, 范围1-500，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        141, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template frame waking speed"),//模板框行走速度
                                        100, 1, 500, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A4, factory));

    //模板框行走加速度, 范围1-10000，默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        142, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template frame waking acceleration"),//模板框行走加速度
                                        500, 1, 10000, 500, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A5, factory));

    //模板框刹车加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        143, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template frame brake acceleration"),//模板框刹车加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A6, factory));

    //上机头旋转归零补偿角度, 范围-1000-1000，默认342
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        144, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Compensation angle of upper machine head rotation return to zero"),//上机头旋转归零补偿角度
                                        342, -1000, 1000, 342, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A7, factory));

    //下机头旋转归零补偿角度, 范围-1000-1000，默认385
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        145, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Compensation angle of lower machine head rotation return to zero"),//下机头旋转归零补偿角度
                                        385, -1000, 1000, 385, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A8, factory));

    //主轴归零补偿角度, 范围-1000--1000,默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        146, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle zero compensation angle"),//主轴归零补偿角度
                                        200, -1000, 1000, 200, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x00A9, factory));

    //平绣机头偏移x, 范围S32_MIN-S32_MAX,默认80000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        150, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery head offset X"),//平绣机头偏移x
                                        80000, S32_MIN, S32_MAX, 80000, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AA, factory));

    //平绣机头偏移y, 范围S32_MIN-S32_MAX,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        151, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery head offset Y"),//平绣机头偏移y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AB, factory));

    //平绣x可绣花区域正边界(X-), 范围S32_MIN-S32_MAX,默认85600
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        152, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat  embroidery X  area negative boundary"),//平绣x可绣花区域正边界(X-)
                                        85600, S32_MIN, S32_MAX, 85600, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AC, factory));


    //平绣x可绣花区域正边界(X+), 范围S32_MIN-S32_MAX,默认207500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        153, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat  embroidery X  area positive boundary"),//平绣x可绣花区域正边界(X+)
                                        207500, S32_MIN, S32_MAX, 207500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AD, factory));

    //平绣Y可绣花区域负边界(Y-), 范围S32_MIN-S32_MAX,默认20300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        154, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat  embroidery X  area positive boundary"),//平绣Y可绣花区域负边界(Y-)
                                        20300, S32_MIN, S32_MAX, 20300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AE, factory));

    //平绣Y可绣花区域负边界(Y+), 范围S32_MIN-S32_MAX,默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        155, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat  embroidery X  area positive boundary"),//平绣Y可绣花区域负边界(Y-)
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00AF, factory));

    //冲孔旋转启动速度, 范围1-720,默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        156, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Start speed of punching rotation"),//冲孔旋转启动速度
                                        10, 1, 720, 10, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B0, factory));

    //冲孔旋转归零速度, 范围1-720,默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        157, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punch rotation zero speed"),//冲孔旋转归零速度
                                        50, 1, 720, 50, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B1, factory));

    //冲孔旋转运转速度, 范围1-720,默认360
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        158, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotating speed of punch"),//冲孔旋转运转速度
                                        360, 1, 720, 360, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B2, factory));

    //冲孔旋转运转加速度, 范围1-10000,默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        159, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Acceleration of ram punch"),//冲孔旋转运转加速度
                                        500, 1, 10000, 500, 0, tr("deg/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B3, factory));

    //冲孔旋转刹车加速度, 范围1-10000,默认5000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        160, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Ram punch rotation brake acceleration"),//冲孔旋转刹车加速度
                                        5000, 1, 10000, 5000, 0, tr("deg/s2"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B4, factory));

    //冲孔旋转最高速度, 范围1-3600,默认720
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        161, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotating speed of punch"),//冲孔旋转最高速度
                                        720, 1, 3600, 720, 0, tr("deg/s"), tr(""),
                                        tr(""),
                                        0, 0, 0x00B5, factory));

    //X间隙补偿, 范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X gap compensation"),//X间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BC, repair));

    //Y间隙补偿, 范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y gap compensation"),//Y间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BD, repair));

    //画笔偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        200, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Brush offset X"),//画笔偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BE, factory));

    //画笔偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        201, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Brush offset Y"),//画笔偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BF, factory));

    //压枣偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        202, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Track offset X"),//压枣偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C0, factory));

    //压枣偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        203, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Track offset Y"),//压枣偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C1, factory));

    //左上料点X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        208, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Left loading point X"),//左上料点X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C2, factory));

    //左上料点Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        209, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Left loading point Y"),//左上料点Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C3, factory));

    //右上料点X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        210, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Right loading point X"),//右上料点X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C4, factory));

    //右上料点Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_POSITION,
                                        211, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Right loading point Y"),//右上料点Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C5, factory));

    //模板框宽度, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        212, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Template box width"),//模板框宽度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00C6, factory));

}

//主控工作参数
void TemplateSewMachine::initWkParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 缝纫工作转速, 范围 1--2000，单位r/min，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_SPEED,
                                        0, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("sewing work speed"),// 缝纫工作转速
                                        1000, 1, 2000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0100, repair));

    // 主轴剪线转速, 范围 1--500，单位r/min，默认120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        1, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle Cut line speed"),// 主轴剪线转速
                                        120, 1, 500, 120, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0101, repair));

    // 主轴回针转速, 范围 1--500，单位r/min，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle Back needle speed"),// 主轴回针转速
                                        200, 1, 500, 200, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0102, repair));

    // 主轴启动慢动转速, 范围 1--500，单位r/min，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        3, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle start slow speed"),// 主轴启动慢动转速
                                        200, 1, 500, 200, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0103, repair));

    // 倒车等效主轴转速, 范围 1--3000，单位r/min，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        4, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Reverse equivalent spindle speed"),// 倒车等效主轴转速
                                        1000, 1, 3000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0104, repair));

    // 缝纫动框方式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        5, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing moving frame"),// 缝纫动框方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Continuous:0;Intermittent:1"), 0, 0, 0x0105, repair));//连续:0;间歇式:1

    // 缝纫加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        5, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing acceleration and deceleration mode"),// 缝纫加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;Xy sine acceleration and deceleration:1"), //无加速或减速:0;Xy正弦加速度和减速度:1
                                        1, 1, 0x0106, repair));

    // 缝纫机头旋转方式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        5, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing machine head rotating manner"),// 缝纫机头旋转方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Continuous rotation:0;Xy intermittent rotation:1"),//连续旋转:0;Xy间歇旋转:1
                                        0, 0, 0x0107, repair));

    // 缝纫机头加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        5, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing head deceleration mode"),// 缝纫机头加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;Intermittent acceleration and deceleration:1"), //无加速或减速:0;间歇加减速:1
                                        1, 1, 0x0108, repair));//无加速或减速：0；间歇加减速：1

    // 缝纫动框起始角度, 范围 0--36000，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        6, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing movable frame starting angle"),// 缝纫动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0109, repair));

    // 缝纫动框持续角度, 范围 0--36000，默认 15000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        7, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing movable frame duration angle"),// 缝纫动框持续角度
                                        15000, 0, 36000, 15000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x010A, repair));

    // 起针慢动针数, 范围 0--10，默认 3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        8, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Start low speed needls"),// 起针慢动针数
                                        3, 0, 10, 3, 0, tr("Needles"), tr(""),
                                        tr(""), 0, 0, 0x010B, repair));

    // 起针动作松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        9, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action loose line allowed"),// 起针动作松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010C, operate));

    // 起针动作顶线允许 0, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        9, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action top line allowed"),// 起针动作顶线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010D, operate));

    // 起针动作夹线允许 0, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        9, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action clamp line allowed"),// 起针动作夹线允许 0
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010E, operate));

    // 绣花起针夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        9, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Allow to embroider line allowed"),// 绣花起针夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0110, operate));

    // 剪线允许, 范围 0--2，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        10, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Cut lines allow"),// 剪线允许
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("Do not trim: 0;Automatic thread trim:1;Data trim:2"),//不剪线:0;自动剪线:1;数据剪线:2
                                        1, 1, 0x0111, operate));

    // 剪线分线角度, 范围 0--36000，默认 20000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        11, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming line angle"),// 剪线分线角度
                                        20000, 0, 36000, 20000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0112, repair));

    // 剪线完成角度, 范围 0--36000，默认 6000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        12, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming completion angle"),// 剪线完成角度
                                        6000, 0, 36000, 6000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0113, repair));

    // 剪线时动作松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action loosening when thread trimming"),// 剪线时动作松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0114, operate));

    // 剪线时动作拉线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action wire pull when thread trimming"),// 剪线时动作拉线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0115, operate));

    // 剪线时动作夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action clip line allows when trimming"),// 剪线时动作夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升压脚允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the presser foot during thread cutting is allowed"),// 剪线时动作提升压脚允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升机头剪线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the machine head during thread cutting allows for thread cutting"),// 剪线时动作提升机头剪线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升机头夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the machine head during thread cutting allows for thread clamping"),// 剪线时动作提升机头夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作在压脚下勾线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        13, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("When cutting the thread, the action is allowed to hook the thread under the pressure foot"),// 剪线时动作在压脚下勾线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 断线检测针数, 范围 0--10，默认 3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_DETECT,
                                        14, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of broken wires"),// 断线检测针数
                                        3, 0, 10, 3, 0, tr("Needles"), tr(""),
                                        tr(""), 0, 0, 0x0117, operate));

    // 断线检测主轴角度, 范围 0--36000，默认 3000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        15, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Broken line detection spindle angle"),// 断线检测主轴角度
                                        3000, 0, 36000, 3000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0118, repair));

    // 换梭芯提醒功能, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_DETECT,
                                        16, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Change bobbin Reminder function"),// 换梭芯提醒功能
                                        0, 0, 3, 0, 0, tr(""), tr(""),  //未启用:0;按长度划分的延迟提醒:1;按切片数计数:2;按长度立即提醒:3
                                        tr("Not:0;Delay reminder by length:1;Count by number of slices:2;Immediately reminder by length:3"),
                                        0, 0, 0x0119, operate));

    // 底线长度, 范围 0--S32_MAX，默认 10000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_DETECT,
                                        17, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bottom line length"),// 底线长度
                                        10000000, 0, S32_MAX, 10000000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x011A, operate));

    // 每针底线修正量, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        18, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bottom line correction per stitch"),// 每针底线修正量
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x011B, operate));

    // 换梭片数计数, 范围 0--1000，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_DETECT,
                                        19, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of shuttles"),// 换梭片数计数
                                        0, 0, 1000, 0, 0, tr("times"), tr(""),
                                        tr(""), 0, 0, 0x011C, operate));

    // 加油方式选择, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        20, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Refueling method selection"),// 加油方式选择
                                        0, 0, 3, 0, 0, tr(""), tr(""),//不加油:0;按工作时间间断加油:1;按工作针数间歇加油:2;持续加油:3
                                        tr("No:0; According to working hours:1; According to the number of working stitches:2; Persistent refueling:3"),
                                        0, 0, 0x011D, operate));

    // 加油针数间隔, 范围 S32_MIN--S32_MAX，默认 10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        21, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling needles interval"),// 加油针数间隔
                                        10000, S32_MIN, S32_MAX, 10000, 0, tr("Needles"), tr(""),
                                        tr(""), 0, 0, 0x011E, operate));

    // 加油时间间隔, 范围 1--S32_MAX，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        22, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling time interval"),// 加油时间间隔
                                        1, 1, S32_MAX, 1, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x011F, operate));

    // 加油持续时长, 范围 1--S32_MAX，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        23, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling duration"),// 加油持续时长
                                        1, 1, S32_MAX, 1, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0120, operate));

    // 完成后停车位置选择, 范围 0--4，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        24, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Parking position selection after completion"),// 完成后停车位置选择
                                        0, 0, 4, 0, 0, tr(""), tr(""),
                                        tr("Current:0;Starting:1;Anchor:2;Feeding:3;Offset:4"),//当前点:0;起始点:1;定位点:2;上料点:3;偏移点:4
                                        0, 0, 0x0121, operate));

    // 偏移点坐标有效标志, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        25, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Offset point coordinate valid flag"),// 偏移点坐标有效标志
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Invalid:0;X is valid:1;Y is valid:2;XY is valid:3"),//无效:0;X有效:1;Y有效:2;XY同时有效:3
                                        0, 0, 0x0122, operate));

    // 偏移点坐标X, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        26, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point coordinate X"),// 偏移点坐标X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0123, operate));

    // 偏移点坐标Y, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        27, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point coordinate Y"),// 偏移点坐标Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0124, operate));

    // 穿线点坐标有效标志, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        28, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Threading point coordinate effective mark"),// 穿线点坐标有效标志
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Invalid:0;X is valid:1;Y is valid:2;XY is valid:3"),//无效:0;X有效:1;Y有效:2;XY同时有效:3
                                        0, 0, 0x0125, operate));

    // 穿线点坐标X, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        29, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Threading point coordinates X"),// 穿线点坐标X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0126, operate));

    // 穿线点坐标 Y, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        30, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Threading point coordinates Y"),// 穿线点坐标Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0127, operate));

    // 机头升降低位高度, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        31, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Machine head low position"),// 机头升降低位高度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0128, repair));

    // 机头升降高位高度, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        32, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Machine head heigh position"),// 机头升降高位高度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0129, repair));

    // 产量预设, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK,
                                        33, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Production preset"),// 产量预设
                                        0, 0, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x012A, operate));

    // 照明亮度, 范围 0--255，默认 128
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        34, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Illumination brightness"),// 照明亮度
                                        128, 0, 255, 128, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x012B, operate));

    // 气框关闭后延时, 范围 0--2000，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        35, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Delay after the air frame is closed"),// 气框关闭后延时
                                        500, 0, 2000, 500, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x012C, operate));

    // 缝纫加速度, 范围 1--100，默认 5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        36, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing acceleration"),// 缝纫加速度
                                        5, 1, 100, 5, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x012D, repair));

    // 剪线动框位移, 范围 1--1000，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        37, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming frame displacement"),// 剪线动框位移
                                        500, 1, 1000, 500, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x012E, operate));

    // 缝纫吹气允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        38, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing blow allowed"),// 缝纫吹气允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, operate));

    // 摆针允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        38, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing the needle allowed"),// 摆针允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, operate));

    // 自动回穿线点允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        38, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic loopback point allowed"),// 自动回穿点允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, operate));

    // 机头旋转允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        38, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing head rotation allowed"),// 机头旋转允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, repair));

    // 送边条允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        38, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Send sidebar allowed"),// 送边条允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, operate));

    // 冲孔吹气允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        39, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching blow allowed"),// 冲孔吹气允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0130, operate));

    // 吸尘器关闭延时, 范围 0--120，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        40, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner off delay"),// 吸尘器关闭延时
                                        0, 0, 120, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0131, operate));

    // 冲孔主轴转速, 范围 1--1200，默认 1200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_SPEED,
                                        41, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle speed"),// 冲孔主轴转速
                                        1200, 1, 1200, 1200, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0132, operate));

    // 冲孔加速度, 范围 1--100，默认 20
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        42, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching acceleration"),// 冲孔加速度
                                        20, 1, 100, 20, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0133, operate));

    // 冲孔动框方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        43, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching movable frame mode"),// 冲孔动框方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("AContinuous:0;BIntermittent:1"), 1, 1, 0x0134, repair));//连续式:0;间歇式:1

    // 冲孔加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        43, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching acceleration and deceleration mode"),// 冲孔加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;XY sine acceleration and deceleration:1"), 1, 1, 0x0135, repair));//无加速或减速:0;XY正弦加速度和减速度:1

    // 冲孔动框起始角度, 范围 0--36000，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        44, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching frame starting angle"),// 冲孔动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0136, repair));

    // 冲孔动框持续角度, 范围 0--36000，默认 15000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        45, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching frame continuous angle"),// 冲孔动框持续角度
                                        15000, 0, 36000, 15000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0137, repair));

    // 缝纫间越框机头升降, 范围 0--max，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        46, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing move head up down"),// 缝纫间越框机头升降
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0138, operate));

    // 冲孔间越框机头升降, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        47, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching move head up down"),// 冲孔间越框机头升降
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0139, operate));

    // 移框松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        48, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Moving basket Loose line"),// 移框松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013A, operate));

    // 移框夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        48, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Moving basket Clamp line"),// 移框夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013B, operate));

    // 软件限位XY移动允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit XY move allowed"),// 软件限位XY移动允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013C, factory));

    // 软件限位缝纫头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit sewing head lifting allowed"),// 软件限位缝纫头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013D, factory));

    // 软件限位冲孔头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit punch head lifting allowed"),// 软件限位冲孔头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013E, factory));

    // 软件限位裁刀机头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit cutter head lift allowed"),// 软件限位裁刀机头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0140, factory));

    // 软件限位冲孔落杆限制允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit Punch drop allowed"),// 软件限位冲孔落杆限制允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0141, factory));

    // 软件限位绣花落杆限制允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        49, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit embroidery falling pole allowed"),// 软件限位绣花落杆限制允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0142, factory));

    // 换梭旋转机头角度, 范围 0--36000，默认 18000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        50, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Shuttle rotation angle"),// 换梭旋转机头角度
                                        18000, 0, 36000, 18000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0143, factory));

    // 旋转持续角度, 范围 0--36000，默认 36000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        51, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Shuttle rotation angle"),// 旋转持续角度
                                        36000, 0, 36000, 36000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0144, operate));

    // 面线勾线针数, 范围 0--5，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        52, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of needle hooks"),// 面线勾线针数
                                        1, 0, 5, 1, 0, tr("needle"), tr(""),
                                        tr(""), 0, 0, 0x0145, operate));

    // 缝纫工作时压脚高度, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        53, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot height during sewing work"),// 缝纫工作时压脚高度
                                        0, 0, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0146, repair));

    // 模拟工作时机头高度, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        54, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head height during simulated work"),// 模拟工作时机头高度
                                        0, 0, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0147, repair));

    // 切刀工作转速, 范围 1--3000，默认 1200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_SPEED,
                                        55, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Cutter working speed"),// 切刀工作转速
                                        1200, 1, 3000, 1200, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x0148, operate));

    // 切刀加速度, 范围 1--100，默认 30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        56, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Cutter acceleration"),// 切刀加速度
                                        30, 1, 100, 30, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x0148, operate));

    // 剪线动框方向, 范围 0--4，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        57, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Trimming frame direction"),// 剪线动框方向
                                        0, 0, 4, 0, 0, tr(""), tr(""),
                                        tr("Stop:0;Left:1;Forward:2;Right:3;Backward:4"),// 禁止移动:0;左:1;前:2;右:3;后:4
                                        0, 0, 0x014A, repair));

    // 压枣升降行程, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        58, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("track formed up and down"),// 压枣升降行程
                                        0, 0, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x014B, repair));

    // 主轴拐角转速, 范围 1--3000，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        59, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle corner speed"),// 主轴拐角转速
                                        1000, 1, 3000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x014C, operate));

    // 降速最小偏差角度, 范围 0--180，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        60, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Minimum speed deviation angle"),// 降速最小偏差角度
                                        0, 0, 180, 0, 0, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x014D, operate));

    // 提前降速针步, 范围 0--10，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        61, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Slow down the needle step in advance"),// 提前降速针步
                                        0, 0, 10, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x014E, operate));

    // 延迟提速针步, 范围 0--10，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        62, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Delay speed up needle step"),// 延迟提速针步
                                        0, 0, 10, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x014F, operate));

    // 冲孔旋转减速最小偏差角度, 范围 0--180，默认 90
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        63, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Minimum deviation angle of punching rotation deceleration"),// 冲孔旋转减速最小偏差角度
                                        90, 0, 180, 90, 0, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x0150, operate));

    // 冲孔旋转持续角度, 范围 0--36000，默认 22000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        64, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punch rotation duration angle"),// 冲孔旋转持续角度
                                        22000, 0, 36000, 22000, 0, cod->toUnicode("°"), tr(""),
                                        tr(""), 22000, 22000, 0x0151, operate));

    // 缝纫机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        65, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Working permission of sewing machine head"),// 缝纫机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0152, operate));

    // 冲孔机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        65, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Work permit of punch head"),// 冲孔机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0153, operate));

    // 绣花机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        65, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Embroidery machine head work permit"),// 绣花机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0154, operate));

    // 开机自动找零开启, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        67, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Auto Zero after power on"),// 绣花机头工作允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0155, repair));

    // 冲头旋转控制1, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 1"),// 冲头旋转控制1
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0156, repair));

    // 冲头旋转控制2, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 2"),// 冲头旋转控制2
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0157, repair));

    // 冲头旋转控制3, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 3"),// 冲头旋转控制3
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0158, repair));

    // 冲头旋转控制4, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 4"),// 冲头旋转控制4
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0159, repair));

    // 冲头旋转控制5, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 5"),// 冲头旋转控制5
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x015A, repair));

    // 冲头旋转控制6, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        68, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punch rotation control 6"),// 冲头旋转控制6
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x015B, repair));

    // 换色启动方式,0,自动换色，自动启动；1，自动换色，手动启动；2，手动换色，手动启动
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        71, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Color change start method"),//换色启动方式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("Automatic color Automatic start:0;Automatic color Manual start:1;Manual color Manual start:2"),
                                        0, 0, 0x015C, operate));

    // X绣框换向补偿, 范围 -100--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X frame commutation compensation"),// X绣框换向补偿
                                        0, -100, 100, 0, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x015D, repair));

    // Y绣框换向补偿, 范围 -100--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y frame commutation compensation"),// Y绣框换向补偿
                                        0, -100, 100, 0, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x015F, repair));

    // 平绣补绣方式, 范围 0--2，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        74, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The way of mending flat embroidery"),// 平绣补绣方式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("mending emb off: 0 ;  mending emb by hand: 1 ; mending emb auto: 2"), //补绣关闭:0;手动:1;自动:2
                                        0, 0, 0x0160, operate));

    // 锁针次数, 范围 0--5，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        75, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Locking times"),// 锁针次数
                                        0, 0, 5, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0161, operate));

    // 锁针步数, 范围 0--5，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        76, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of needle locking steps"),// 锁针步数
                                        0, 0, 5, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0162, operate));

    // 锁针针步长度, 范围 0--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        77, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of lock needle"),// 锁针针步长度
                                        0, 0, 100, 0, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0163, operate));

    // 开始工作模式, 0，从停车点开始；1，从当前位置开始，不保存；2，从当前位置开始，保存 , 默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        78, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Start working position mode"),// 锁针针步长度
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("From the Stop lot: 0 ;  From the current location, do not save: 1 ; From the current location,  save: 2"),
                                        0, 0, 0x0164, operate));

    // 冲孔跳针变越框针数 ,范围0-100，单位，针，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        79, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching jump stitches to change the number of stitches beyond the frame"),// 冲孔跳针变越框针数
                                        5, 0, 100, 5, 0, tr("Needles"), tr(""),
                                        tr(""), 0, 0, 0x0165, repair));

    // 冲孔点动模式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        80, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching jog mode"),// 冲孔点动模式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Lock rotate:0;rotate Lock:1"), 0, 0, 0x0161, repair));//0，先锁头，再旋转;1,先旋转，再锁头

    // 倒车工作模式, 范围 0--2，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        81, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Reverse operation mode"),// 倒车工作模式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("normal:0;click:1;continue click:2"), 0, 0, 0x0162, repair));//0，普通模式；1，点动模式；2,持续点动模式

    // 特殊针位选择, 范围 0--9，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        82, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle choose"),// 特殊针位选择
                                        0, 0, 9, 0, 0, tr(""), tr(""),
                                        tr("nothing:0;one:1;two:2;three:3;four:4;five:5;six:6;seven:7;eight:8;nine:9"),
                                        0, 0, 0x0163, factory));//0，无；1-9，1-9针位

    // 特殊针位功能, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        83, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle function"),// 特殊针位功能
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Carved hole:0;paint brush:1"), 0, 0, 0x0164, factory));//0，雕孔；1，画笔

    // 吸尘器启动延时, 范围 0--S32_MAX，单位秒,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        84, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner start delay"),// 吸尘器启动延时
                                        0, 0, S32_MAX, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0165, operate));

    // 换色速度，范围1-2000，单位mm/s,默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        99, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Color change speed"),// 换色速度
                                        200, 1, 2000, 200, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x0167, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("first head"),//  第一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0170, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("second head"),//  第二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0171, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 3, 0, PARA_VALUE_TYPE_SW,
                                        tr("third head"),//  第三个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0172, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 4, 0, PARA_VALUE_TYPE_SW,
                                        tr("fourth head"),//  第四个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0173, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 5, 0, PARA_VALUE_TYPE_SW,
                                        tr("fifth head"),//  第五个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0174, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 6, 0, PARA_VALUE_TYPE_SW,
                                        tr("sixth head"),//  第六个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0175, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 7, 0, PARA_VALUE_TYPE_SW,
                                        tr("seventh head"),//  第七个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0176, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 8, 0, PARA_VALUE_TYPE_SW,
                                        tr("eighth head"),//  第八个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0177, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 9, 0, PARA_VALUE_TYPE_SW,
                                        tr("ninth head"),//  第九个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0178, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 10, 0, PARA_VALUE_TYPE_SW,
                                        tr("tenth head"),//  第十个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0179, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 11, 0, PARA_VALUE_TYPE_SW,
                                        tr("eleventh head"),//  第十一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017A, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 12, 0, PARA_VALUE_TYPE_SW,
                                        tr("twelfth head"),//  第十二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017B, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 13, 0, PARA_VALUE_TYPE_SW,
                                        tr("thirteenth head"),//  第十三个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017C, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 14, 0, PARA_VALUE_TYPE_SW,
                                        tr("fourteenth head"),//  第十四个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017D, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 15, 0, PARA_VALUE_TYPE_SW,
                                        tr("fifteenth head"),//  第十五个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017E, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 16, 0, PARA_VALUE_TYPE_SW,
                                        tr("sixteent head"),//  第十六个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x017F, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 17, 0, PARA_VALUE_TYPE_SW,
                                        tr("seventeenth head"),//  第十七个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0180, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 18, 0, PARA_VALUE_TYPE_SW,
                                        tr("eighteenth head"),//  第十八个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0181, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 19, 0, PARA_VALUE_TYPE_SW,
                                        tr("nineteenth head"),//  第十九个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0182, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 20, 0, PARA_VALUE_TYPE_SW,
                                        tr("twentieth head"),//  第二十个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0183, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 21, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-first head"),//  第二十一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0184, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 22, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-second head"),//  第二十二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0185, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 23, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-third head"),//  第二十三个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0186, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 24, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-fourth head"),//  第二十四个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0187, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 25, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-fifth head"),//  第二十五个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0188, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 26, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-sixth head"),//  第二十六个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0189, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 27, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-seventh head"),//  第二十七个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018A, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 28, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-eighth head"),//  第二十八个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018B, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 29, 0, PARA_VALUE_TYPE_SW,
                                        tr("twenty-ninth head"),//  第二十九个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018C, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 30, 0, PARA_VALUE_TYPE_SW,
                                        tr("thirtieth head"),//  第三十个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018D, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 31, 0, PARA_VALUE_TYPE_SW,
                                        tr("thirty-first head"),//  第三十一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018E, repair));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 32, 0, PARA_VALUE_TYPE_SW,
                                        tr("thirty-second head"),//  第三十二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x018F, repair));

    // 安全输入光幕允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        101, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Secure input light curtain allows"),// 安全输入光幕允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0190, repair));

    // 安全输入气压允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        101, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safety input pressure allowed"),// 安全输入气压允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0191, repair));

    // 安全输入上电信号允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        101, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safe input power-on signal allowed"),// 安全输入上电信号允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0192, repair));

    // 安全输入安全门允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        101, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safe input emergency door allowed"),// 安全输入安全门允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0193, repair));

    // 自动气框允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        102, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic air box allowed"),// 自动气框允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0194, operate));

    // 自动气框延时闭合, 范围 0--5000，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        103, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Automatic air frame closing delay"),// 自动气框延时闭合
                                        0, 0, 5000, 0, 0, tr("ms"), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0195, operate));

    // 线迹偏移允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        104, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Stitch offset allows"),// 线迹偏移允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0196, operate));

    // 循环工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_ACTION,
                                        105, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Loop work allowed"),// 循环工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0197, operate));

    // 右机头选择1, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 1"),// 右机头选择1
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0198, repair));

    // 右机头选择2, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 2"),// 右机头选择2
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0199, repair));

    // 右机头选择3, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 3, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 3"),// 右机头选择3
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019A, repair));

    // 右机头选择4, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 4, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 4"),// 右机头选择4
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019B, repair));

    // 右机头选择5, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 5, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 5"),// 右机头选择5
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019C, repair));

    // 右机头选择6, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 6, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 6"),// 右机头选择6
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019D, repair));

    // 右机头选择7, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 7, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 7"),// 右机头选择7
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019E, repair));

    // 右机头选择8, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 8, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 8"),// 右机头选择8
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x019F, repair));

    // 右机头选择9, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 9, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 9"),// 右机头选择9
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A0, repair));

    // 右机头选择10, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 10, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 10"),// 右机头选择10
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A1, repair));

    // 右机头选择11, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 11, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 11"),// 右机头选择11
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A2, repair));

    // 右机头选择12, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 12, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 12"),// 右机头选择12
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A3, repair));

    // 右机头选择13, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 13, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 13"),// 右机头选择13
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A4, repair));

    // 右机头选择14, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 14, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 14"),// 右机头选择14
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A5, repair));

    // 右机头选择15, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 15, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 15"),// 右机头选择15
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A6, repair));

    // 右机头选择16, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 16, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 16"),// 右机头选择16
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A7, repair));

    // 右机头选择17, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 17, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 17"),// 右机头选择17
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A8, repair));

    // 右机头选择18, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 18, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 18"),// 右机头选择18
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01A9, repair));

    // 右机头选择19, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 19, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 19"),// 右机头选择19
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AA, repair));

    // 右机头选择20, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 20, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 20"),// 右机头选择20
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AB, repair));

    // 右机头选择21, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 21, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 21"),// 右机头选择21
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AC, repair));

    // 右机头选择22, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 22, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 22"),// 右机头选择22
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AD, repair));

    // 右机头选择23, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 23, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 23"),// 右机头选择23
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AE, repair));

    // 右机头选择24, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 24, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 24"),// 右机头选择24
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01AF, repair));

    // 右机头选择25, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 25, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 25"),// 右机头选择25
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B0, repair));

    // 右机头选择26, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 26, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 26"),// 右机头选择26
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B1, repair));

    // 右机头选择27, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 27, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 27"),// 右机头选择27
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B2, repair));

    // 右机头选择28, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 28, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 28"),// 右机头选择28
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B3, repair));

    // 右机头选择29, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 29, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 29"),// 右机头选择29
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B4, repair));

    // 右机头选择30, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 30, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 30"),// 右机头选择30
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B5, repair));

    // 右机头选择31, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 31, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 31"),// 右机头选择31
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B6, repair));

    // 右机头选择32, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        106, 32, 0, PARA_VALUE_TYPE_SW,
                                        tr("Right Work head selection 32"),// 右机头选择32
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01B7, repair));

    // 拉料电机拉料位置, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Pulling motor pull position"),// 拉料电机拉料位置
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01B8, repair));

    // 拉料长度, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        108, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Pull length"),// 拉料长度
                                        0, 0, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01BA, operate));

    // 裁切长度, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        109, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Cutting length"),// 裁切长度
                                        0, 0, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01BB, operate));

    // 梭加油持续时间, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Shuttle refueling duration"),// 梭加油持续时间
                                        0, 0, S32_MAX, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x01BC, operate));

    // 夹线力度1, 范围 0--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        111, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Clamping force 1"),// 夹线力度1
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01BD, operate));

    // 夹线力度2, 范围 0--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        112, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Clamping force 2"),// 夹线力度2
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01BE, operate));

    // 夹线力度3, 范围 0--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        113, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Clamping force 3"),// 夹线力度3
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01BF, operate));

    // 夹线力度4, 范围 0--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        114, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Clamping force 4"),// 夹线力度4
                                        0, 0, 100, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x01C0, operate));

    // 平绣主轴工作转速, 范围 1--1200，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_WORK|MC_SORT_SPEED,
                                        115, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery spindle working speed"),// 平绣主轴工作转速
                                        1000, 1, 1200, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x01C1, operate));

    // 平绣加速度, 范围 1--100，默认 5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        116, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery acceleration"),// 平绣加速度
                                        5, 1, 100, 5, 0, tr("r/ss"), tr(""),
                                        tr(""), 0, 0, 0x01C2, operate));

    // 平绣动框方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        117, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flat embroidery frame"),// 平绣动框方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("continuous: 0 ; intermittent: 1"), 1, 1, 0x01C3, repair));//连续:0;间歇:1

    // 平绣动框方式 xy间歇式脉冲无加减速, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        117, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flat embroidery acceleration mode"),// 平绣动框方式 xy间歇式脉冲无加减速
                                        1, 0, 1, 1, 0, tr(""), tr(""), //无加速或减速:0;XY正弦加减速:1
                                        tr("No acceleration or deceleration: 0 ; Xy sine acceleration and deceleration: 1"),
                                        1, 1, 0x01C4, repair));

    // 平绣动框起始角度, 范围 0--36000，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        118, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery frame starting angle"),// 平绣动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x01C5, repair));

    // 平绣动框持续角度, 范围 0--36000，默认 20000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        119, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery frame continuous angle"),// 平绣动框持续角度
                                        20000, 0, 36000, 20000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x01C6, repair));

    // 跳针最大速度, 范围 100--1200，默认 600
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        120, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("jump max speed"),// 跳针最大速度
                                        600, 100, 1200, 600, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x01C7, operate));

    // 平绣跳针变越框针数, 范围 0--20，默认 3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        121, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery jump to offset Needles count"),// 平绣跳针变越框针数
                                        3, 0, 20, 3, 0, tr("needle"), tr(""),
                                        tr(""), 0, 0, 0x01C8, operate));

    // 平绣动框最高速度, 范围 10--1000，默认 100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        122, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Embroidery move max speed"),// 平绣动框最高速度
                                        100, 10, 1000, 100, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x01C9, repair));

    // 冲孔主轴启动慢动转速, 范围 1--2000，单位r/min，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        169, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle start slow speed"),// 冲孔主轴启动慢动转速
                                        500, 1, 2000, 500, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x01CA, operate));

    // X工作范围, 范围 0--500000，默认 90000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        174, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X working range"),//  X工作范围
                                        90000, 0, 500000, 90000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01CB, factory));

    // Y工作范围, 范围 0--5000000，默认 60000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y working range"),// Y工作范围
                                        60000, 0, 500000, 60000, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01CC, factory));

    // 冲孔旋转传感器角度，范围-36000--36000，单位0.01度，默认9000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        176, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching rotation sensor angle"),// 冲孔旋转传感器角度
                                        9000, -36000, 36000, 9000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x01CD, repair));

    // 冲孔动框最高速度，范围1-1000，单位mm/s，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Maximum speed of punching frame"),// 冲孔动框最高速度
                                        200, 1, 1000, 200, 0, tr("mm/s"), tr(""),
                                        tr(""), 0, 0, 0x01CE, repair));

    // 绣花剪线勾线延迟，范围0-500，单位ms，默认250
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        178, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Embroidery trimming thread hooking delay"),// 绣花剪线勾线延迟
                                        250, 0, 500, 250, 0, tr("ms"), tr(""),
                                        tr(""), 0, 0, 0x01CF, operate));

    // 冲孔运针变跳针长度，范围0-2000，单位0.01mm,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING|MC_SORT_POSITION,
                                        180, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of punching needle changing to skipping needle"),// 冲孔运针变跳针长度
                                        0, 0, 2000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x01D0, operate));

    // 冲孔吸尘器启动持续时间，范围0-100，单位s，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        181, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching vacuum cleaner start duration"),// 冲孔吸尘器启动持续时间
                                        5, 0, 100, 5, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x01D1, operate));

    // 冲孔吸尘器启动间隔，范围0-500，单位s，默认60
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        182, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching vacuum cleaner start interval"),// 冲孔吸尘器启动间隔
                                        60, 0, 500, 60, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x01D2, operate));

    // 平绣扣线角度，范围0--360，单位度，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        185, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Flat embroidery thread angle"),// 平绣扣线角度
                                        100, 0, 360, 100, 0, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x01D3, repair));

}

//电机和控制动作
void TemplateSewMachine::initOutCtrlList()
{
    m_allOutCtrlList.clear();

    QString enableStr = tr("Enable");   //使能
    QString disableStr = tr("Disable"); //失能
    QString jogPStr = tr("JogP"); //正转
    QString jogNStr = tr("JogN"); //反转
    QString zeroStr = tr("Zero"); //归零
    QString openStr = tr("Open"); //打开
    QString closeStr = tr("Close");//关闭
    QString startStr = tr("Start"); //开始
    QString stopStr = tr("Stop");//停止
    QString upStr = tr("Up"); //上升
    QString downStr= tr("Down");//下降
    QString clampStr = tr("Clamp"); //夹紧
    QString relaxStr= tr("Relax");//放松
    QString outStr = tr("Out"); //伸出
    QString backStr= tr("Back");//收回

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("X to move motor"),MT_LX,// X向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0002,tr("Y to move motor"),MT_LY,// Y向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("Sewing needle spindle motor"),MT_LM,// 缝纫主轴电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("Needle motor"),MT_LN,// 针电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("Shuttle motor"),MT_LH,// 梭电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Lift motor"),MT_LU,// 升降电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("ratating motor"),MT_LR,// 旋转电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Up ratating motor"),MT_LRU,// 上旋转电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Down ratating motor"),MT_LRD,// 下旋转电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0005,tr("Punch main axis"),MT_LPM,// 冲孔主轴电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Embroider main axis motor"),MT_LEM,// 绣花主轴电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Punching color change motor"),MT_LPS,// 冲孔换色电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Punching color rorating motor"),MT_LPR,// 冲孔旋转电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Embroidered color rorating motor"),MT_ECM,// 平绣换色电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Embroider Needle Spindle"),MT_EMN,// 平绣针主轴
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Embroider shutle Spindle"),MT_EMH,// 平绣梭主轴
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0007,tr("loose thread"),OT_LOOSE_THREAD,//松紧线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             relaxStr,true,OUTCONTROL_OPEN,-1,-1,
                                             clampStr,true,OUTCONTROL_CLOSE,-1,-1));

//    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0008,tr("up cutter cut"),OT_UCUT_THREAD,//上剪刀剪线
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
//                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0009,tr("down cutter cut"),OT_DCUT_THREAD,//下剪刀剪线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000A,tr("fuel charging"),OT_OIL,//加油
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             startStr,true,OUTCONTROL_OPEN,-1,-1,
                                             stopStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000B,tr("light  "),OT_LIGHT,//照明灯
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("mid press foot"),OT_MID_FOOT,//中压脚
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000E,tr("kou blow thread"),OT_PUSH_BTRD,//扣底线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000F,tr("clip up thread"),OT_CLIP_UTRD,//夹面线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             clampStr,true,OUTCONTROL_OPEN,-1,-1,
                                             relaxStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0011,tr("sewing head lift"),OT_SEW_LIFT,//缝纫机头升降
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             upStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             downStr,true,OUTCONTROL_DISABLE,-1,-1));

//    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000A,tr("punching head lift"),OT_PUNCH_LIFT,//冲孔机头升降
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             upStr,true,MOTORHEADO_UP,-1,-1,
//                                             downStr,true,MOTORHEADO_DOWN,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0012,tr("sew blow"),OT_PUSH_BTRD,//缝纫吹气
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

//    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0012,tr("kou blow thread"),OT_PUNCH_BLOW,//冲孔吹气
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
//                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0013,tr("cleaner "),OT_CLEANER,//吸尘器
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0014,tr("Hook action extension"),OT_CLIP_EXTEND,//勾线动作伸缩
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             outStr,true,OUTCONTROL_OPEN,-1,-1,
                                             backStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0015,tr("Hook action opening and closing"),OT_CLIP_EXTEND,//勾线动作开合
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0016,tr("embroider cutter"),OT_EMB_CUT,//平绣剪刀
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0017,tr("embroider push"),OT_EMB_PUSH,//平绣扣线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0018,tr("embroider clip thread"),OT_EMB_CLIP,//平绣夹面线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0019,tr("embroider fuel charging"),OT_EMB_OIL,//平绣加油
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001A,tr("embroider hook thread"),OT_EMB_HOOK,//平绣勾线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001B,tr("embroider lock"),OT_EMB_LOCK,//平绣锁头
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

//    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001C,tr("punch fuel charging"),OT_PUNCH_OIL,//冲孔加油
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
//                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));
//    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001D,tr("punch lock"),OT_PUNCH_LOCK,//冲孔锁头
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             "",false,-1,-1,-1,
//                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
//                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));
}

//初始化快捷功能列表
void TemplateSewMachine::initShortCutList()
{
    m_allShortCutList.clear();

    m_allShortCutList.append(makeAShortCutItem(0,0x0001,tr("All To Zero"),"buttonAllToZero",FUN_ALLTOZERO));//全部归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0002,tr("Set Offset"),"buttonSetOffsetPoint",FUN_SETOFFSETPOINT));//定偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x0003,tr("Sew Start"),"buttonSetStartPoint",FUN_SETSTARTPOINT));//缝纫定起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x0004,tr("Sew Anchor"),"buttonSetAnchorPoint",FUN_SETANCHORPOINT));//缝纫定定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x0005,tr("Punch Start"),"buttonSetStartPoint",FUN_SECSETSTARTPOINT));//冲孔定起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x0006,tr("Punch Anchor"),"buttonSetAnchorPoint",FUN_SECSETANCHORPOINT));//冲孔定定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x0007,tr("Emb Start"),"buttonSetStartPoint",FUN_THRIDSETSTARTPOINT));//绣花定起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x0008,tr("Emb Anchor"),"buttonSetAnchorPoint",FUN_THRIDSETANCHORPOINT));//绣花定定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x0009,tr("Check Frame"),"buttonBorderCheck",FUN_CHECKFRAME));//边框检查
    m_allShortCutList.append(makeAShortCutItem(0,0x000A,tr("Back Offset"),"buttonBackOffsetPoint",FUN_BACKOFFSETPOINT));//回偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x000B,tr("Back Start"),"buttonBackAnchorPoint",FUN_BACKSTARTPOINT));//回起始点
    m_allShortCutList.append(makeAShortCutItem(0,0x000C,tr("To Work Point"),"buttonBackWorkPoint",FUN_BACKWORKPOINT));//回工作点
    m_allShortCutList.append(makeAShortCutItem(0,0x000D,tr("To anchor Point"),"buttonBackAnchorPoint",FUN_BACKANCHORPOINT));//回定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x000E,tr("Back to nthreading point"),"buttonBackWorkPoint",FUN_BACKTHREADPOINT));//回穿线点
    m_allShortCutList.append(makeAShortCutItem(0,0x000F,tr("To Center point"),"buttonToCenterDot",FUN_RETURNTOCENTERPOINT));//回中心点
    m_allShortCutList.append(makeAShortCutItem(0,0x0010,tr("Frame Zero"),"buttonFrameZero",FUN_FRAMEZERO));//框架归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0011,tr("To Right Up"),"buttonMoveToRightUp",FUN_MOVETORIGHTUP));//去右上角
    m_allShortCutList.append(makeAShortCutItem(0,0x0012,tr("To Right Down"),"buttonMoveToRightDown",FUN_MOVETORIGHTDOWN));//去右下角
    m_allShortCutList.append(makeAShortCutItem(0,0x0013,tr("To Left Up"),"buttonMoveToLeftUp",FUN_MOVETOLEFTUP));//去左上角
    m_allShortCutList.append(makeAShortCutItem(0,0x0014,tr("To Left Down"),"buttonMoveToLeftDown",FUN_MOVETOLEFTDOWN));//去左下角
    m_allShortCutList.append(makeAShortCutItem(0,0x0015,tr("Scope Work"),"buttonSetWorkRange",FUN_SETWORKRANGE));//定工作范围
    m_allShortCutList.append(makeAShortCutItem(0,0x0016,tr("Sew Spindle Test"),"buttonSpindleTest",FUN_SEWSPINDLETEST));// 缝纫主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x0017,tr("Sew trim"),"buttonManualTrim",FUN_SEWHEADCUTLINEO));//缝纫剪线
    m_allShortCutList.append(makeAShortCutItem(0,0x0018,tr("Sew Head Up Dn"),"buttonHeadUpDn",FUN_SEWMOTORUPDOWN));//缝纫机头升降
    m_allShortCutList.append(makeAShortCutItem(0,0x0019,tr("Sew Spindle Jog"),"buttonSpindleJog",FUN_SEWSPINDLEJOG));//缝纫主轴点动
    m_allShortCutList.append(makeAShortCutItem(0,0x001A,tr("Sew Hook Position"),"buttonSewHookPosi",FUN_SEWHOOKPOSITION));//缝纫主轴去勾线位
    m_allShortCutList.append(makeAShortCutItem(0,0x001B,tr("Rotate nproofreading"),"buttonSpindleRotate",FUN_ROTATEPROOFREAD));//缝纫旋转校对
    m_allShortCutList.append(makeAShortCutItem(0,0x001C,tr("Switch Sew Head"),"buttonSewHead",FUN_SELECTSEWHEAD));//切换缝纫机头
    m_allShortCutList.append(makeAShortCutItem(0,0x001D,tr("Punch Spindle Jog"),"buttonSpindleJog",FUN_PUNCHSPINDLEJOG));//冲孔主轴点动
    m_allShortCutList.append(makeAShortCutItem(0,0x001E,tr("Punch Spindle Test"),"buttonSpindleTest",FUN_SPINDLETEST));//冲孔主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x001F,tr("Punching Change Tool"),"buttonManualChangeColor",FUN_PUNCHMANUALCHANGECOLOR));//冲孔换刀
    m_allShortCutList.append(makeAShortCutItem(0,0x0020,tr("Punch Rod Zero"),"buttonPunchRodZero",FUN_PUNCHNEEDLEZERO));//冲孔换杆归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0021,tr("Single Punch"),"buttonSinglePunch",FUN_SINGLEPUNCH));//单次冲孔
    m_allShortCutList.append(makeAShortCutItem(0,0x0022,tr("Punch Stop Lower"),"buttonPunchStopLower",FUN_PUNCHSTOPLOWER));//冲头停下位
    m_allShortCutList.append(makeAShortCutItem(0,0x0023,tr("Rotate To Zero"),"buttonRotToZero",FUN_PUNCH_ROT_TO_ZERO));//冲孔旋转去零位
    m_allShortCutList.append(makeAShortCutItem(0,0x0024,tr("Switch Punch Head"),"buttonPunchHead",FUN_SELECTPUCNHHEAD));//切换冲孔机头
    m_allShortCutList.append(makeAShortCutItem(0,0x0025,tr("Emb spindle"),"buttonSpindleTest",FUN_SEWEMBSPINDLETEST));//平绣主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x0026,tr("Emb Hook Position"),"buttonEmbHookPosi",FUN_EMBHOOKPOSITION));//平绣主轴去勾线位
    m_allShortCutList.append(makeAShortCutItem(0,0x0027,tr("Emb jog"),"buttonSinglePunch",FUN_SEWEMBSPINDLEJOG));//平绣点动
    m_allShortCutList.append(makeAShortCutItem(0,0x0028,tr("Emb thread cut"),"buttonManualTrim",FUN_SEWEMBCUTLINE));//平绣剪线
    m_allShortCutList.append(makeAShortCutItem(0,0x0029,tr("Emb change color"),"buttonManualChangeColor",FUN_SEWEMBCHANGECOLOR));//平绣换色
    m_allShortCutList.append(makeAShortCutItem(0,0x002A,tr("Switch Emb Head"),"buttonHeadEmb",FUN_SELECTEMBHEAD));//切换平绣机头
    m_allShortCutList.append(makeAShortCutItem(0,0x002B,tr("Forward And Back"),"buttonForwardOrBack",FUN_FORWARDORBACK));//前进回退
    //    m_allShortCutList.append(makeAShortCutItem(0,0x0010,tr("ProcessReset"),"buttonProcessReset",FUN_PROCESSRESET));//流程复位
    m_allShortCutList.append(makeAShortCutItem(0,0x002C,tr("Needle shuttle proofread"),"buttonNeedleTest",FUN_NEEDLECONTRAST));//针梭校对
    m_allShortCutList.append(makeAShortCutItem(0,0x002D,tr("Needle shuttle reset"),"buttonAllToZero",FUN_NEEDLESHUTTLERESET));//针梭复位
    m_allShortCutList.append(makeAShortCutItem(0,0x002E,tr("Back shuttle pos"),"buttonAllToZero",FUN_BACKSHUTTLEPOS));//回换梭位
    m_allShortCutList.append(makeAShortCutItem(0,0x002F,tr("Needle reset"),"buttonFlatEmbHook",FUN_NEEDLERESET));//针归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0030,tr("Shuttle reset"),"buttonBackFeedingPoint",FUN_SHUTTLERESET));//梭归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0031,tr("Sew rotate up"),"buttonSpindleRotate",FUN_SEWROTATEUP));//缝纫旋转+
    m_allShortCutList.append(makeAShortCutItem(0,0x0032,tr("Sew rotate down"),"buttonSpindleRotate",FUN_SEWROTATEDOWN));//缝纫旋转-
}

//初始化辅助功能列表
void TemplateSewMachine::initAssistList()
{
    m_allAssistList.clear();

    m_allAssistList.append(makeAAssistItem(0,0x0001,tr("SensorSign"),"buttonSensor",ASSIST_SENSOR));//传感器信号
    m_allAssistList.append(makeAAssistItem(0,0x0002,tr("Action"),"buttonControlAction",ASSIST_CONTROLACTION));//控制动作
    m_allAssistList.append(makeAAssistItem(0,0x0003,tr("HMIUpgrade"),"buttonHMIUpgrade",ASSIST_HMIUPGRADE));//界面升级
    m_allAssistList.append(makeAAssistItem(0,0x0004,tr("MCUpgrade"),"buttonMCUpgrade",ASSIST_MCUPGRADE));//主控升级
    m_allAssistList.append(makeAAssistItem(0,0x0006,tr("ParaImport"),"buttonParaImport",ASSIST_PARAIMPORT));//参数导入
    m_allAssistList.append(makeAAssistItem(0,0x0007,tr("ParaExport"),"buttonParaExport",ASSIST_PARAEXPORT));//参数导出
    m_allAssistList.append(makeAAssistItem(0,0x0008,tr("SoftwareSet"),"buttonSoftwareSet",ASSIST_SOFTWARESET));//软件设置
    m_allAssistList.append(makeAAssistItem(0,0x0009,tr("SoftPower"),"buttonSoftwareAuthor",ASSIST_AUTHORIZATION));//软件授权
    m_allAssistList.append(makeAAssistItem(0,0x000A,tr("Network"),"buttonNetworkManage",ASSIST_NETWORK));//网络管理
    m_allAssistList.append(makeAAssistItem(0,0x000B,tr("NeedleSet"),"buttonNeedleSet",ASSIST_NEEDLESET));//针杆设置
    m_allAssistList.append(makeAAssistItem(0,0x000C,tr("TimeSet"),"buttonTimeSet",ASSIST_TIMESET));//时间设置
    m_allAssistList.append(makeAAssistItem(0,0x000D,tr("ShortcutSet"),"buttonCommonFunction",ASSIST_SHORTCUTSET));//常用设置
    m_allAssistList.append(makeAAssistItem(0,0x000E,tr("Productnum"),"buttonProductStatistics",ASSIST_PRODUCTSTATICS));//生产统计
    m_allAssistList.append(makeAAssistItem(0,0x000F,tr("Version"),"buttonVersionInfo",ASSIST_MCVERSION));//版本信息
    m_allAssistList.append(makeAAssistItem(0,0x0016,tr("Debug"),"buttonRoot",ASSIST_DEBUG));//调试功能
    m_allAssistList.append(makeAAssistItem(0,0x0010,tr("CountReset"),"buttonBottomCountReset",ASSIST_BOTTOMLINECOUNTRESET));//底线计数复位
    m_allAssistList.append(makeAAssistItem(0,0x0014,tr("Root"),"buttonRoot",ASSIST_ROOT));//超级用户
}

//初始化花样设置列表
void TemplateSewMachine::initPatternSetList()
{
    m_allPatternSetList.clear();

    m_allPatternSetList.append(makeAPatternSetItem(0,0x0001,tr("Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT));//花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0002,tr("Para"),"buttonPatternPara",PATTERNSET_PATTERNPARA));//花样参数
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0003,tr("Color"),"buttonPatternColorOrder",PATTERNSET_PATTERNCOLOR));//花样色序
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0004,tr("Import"),"buttonPatternImport",PATTERNSET_PATTERNIMPORT));//花样导入
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0005,tr("Export"),"buttonPatternExport",PATTERNSET_PATTERNEXPORT));//花样导出
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0006,tr("Delete"),"buttonPatternDelete",PATTERNSET_PATTERNDELETE));//花样删除
}

//初始化参数设置列表
void TemplateSewMachine::initParaSetList()
{
    m_allParaSetList.clear();

    m_allParaSetList.append(makeAParaSetItem(0,0x0001,tr("WorkPara"),"buttonWorkParas",PARASET_WORK));//工作参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0002,tr("OperatPara"),"buttonOperatParas",PARASET_SETTING));//设置参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0003,tr("ActionSet"),"buttonActionParas",PARASET_ACTION));//动作参数   //动作设定
    m_allParaSetList.append(makeAParaSetItem(0,0x0004,tr("SpeedPara"),"buttonSpeedParas",PARASET_SPEED));//速度参数  //速度控制参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0005,tr("LimitPara"),"buttonPositionParas",PARASET_POSITION));// 位置参数  //限位参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0006,tr("DetectPara"),"buttonSettingParas",PARASET_DETECT));//检测参数    //检测参数
}

//初始化调试功能
void TemplateSewMachine::initDebugFunList()
{
    m_allDebugFunList.clear();

    m_allDebugFunList.append(makeADebugItem(0,0x0001,tr("CutLine"),"buttonPosParas",DEBUG_TRIM));//剪线调试
    m_allDebugFunList.append(makeADebugItem(0,0x0002,tr("PunchKnife"),"buttonSpeedParas",DEBUG_DIECUTTER));//冲刀调试
    m_allDebugFunList.append(makeADebugItem(0,0x0003,tr("NeedleShuttle"),"buttonSpeedParas",DEBUG_NEEDLESHUTTLE));//针梭调试
}


//初始化传感器列表
void TemplateSewMachine::initSensorList()
{
    QList <SensorItem> sensorList;

    sensorList.append(makeASensorItem(0x0000, 0, tr("Start button")));//启动按钮
    sensorList.append(makeASensorItem(0x0001, 0, tr("Pause button")));//暂停按钮
    sensorList.append(makeASensorItem(0x0002, 0, tr("Jog button")));//点动按钮
    sensorList.append(makeASensorItem(0x0007, 0, tr("Air pressure protection input")));//气压保护输入
    sensorList.append(makeASensorItem(0x0008, 0, tr("Safety light curtains protection input")));//安全光幕输入
    sensorList.append(makeASensorItem(0x0020, 0, tr("X zero position")));//X零位
    sensorList.append(makeASensorItem(0x0020, 1, tr("Y zero position")));//Y零位
    sensorList.append(makeASensorItem(0x0021, 0, tr("X deceleration")));//X降速
    sensorList.append(makeASensorItem(0x0021, 1, tr("Y deceleration")));//Y降速
    sensorList.append(makeASensorItem(0x0022, 0, tr("X negative limit")));//X负限位
    sensorList.append(makeASensorItem(0x0022, 1, tr("Y negative limit")));//Y负限位
    sensorList.append(makeASensorItem(0x0023, 0, tr("X positive limit")));//X正限位
    sensorList.append(makeASensorItem(0x0023, 1, tr("Y positive limit")));//Y正限位
    sensorList.append(makeASensorItem(0x0030, 0, tr("Sewing on the machine head rotation zero position")));//缝纫上机头旋转零位
    sensorList.append(makeASensorItem(0x0036, 0, tr("Sewing under the machine head rotation zero position")));//缝纫下机头旋转零位
    sensorList.append(makeASensorItem(0x003E, 0, tr("Punching the rotary shaft at zero")));//冲孔旋转轴零位
    sensorList.append(makeASensorItem(0x0040, 0, tr("Sewing machine head  lifting upper limit")));//缝纫机头升降上限位
    sensorList.append(makeASensorItem(0x0042, 0, tr("Lower lifting limit of sewing machine head")));//缝纫机头升降下限位
    sensorList.append(makeASensorItem(0x0080, 0, tr("Sewing spindle  needle - parking space")));//缝纫针主轴停车位
    sensorList.append(makeASensorItem(0x0082, 0, tr("Sewing spindle  needle - thread hooking position")));//缝纫针主轴勾线位
    sensorList.append(makeASensorItem(0x0088, 0, tr("Sewing shuttle  parking space")));//缝纫梭主轴停车位
    sensorList.append(makeASensorItem(0x008A, 0, tr("Sewing rotary hook thread hook position")));//缝纫梭主轴勾线位
    sensorList.append(makeASensorItem(0x0090, 0, tr("Punching spindle zero position")));//冲孔主轴零位
    sensorList.append(makeASensorItem(0x0098, 0, tr("Flat needle spindle parking space")));//平绣针主轴停车位
    sensorList.append(makeASensorItem(0x009A, 0, tr("Flat embroidery needle spindle hook position")));//平绣针主轴勾线位
    sensorList.append(makeASensorItem(0x009C, 0, tr("Flat shuttle spindle parking space")));//平绣梭主轴停车位
    sensorList.append(makeASensorItem(0x009E, 0, tr("Flat embroidery shuttle spindle hook position")));//平绣梭主轴勾线位
    sensorList.append(makeASensorItem(0x0100, 0, tr("Flat embroidery under the scissors back in place")));//平绣下剪刀回位
    sensorList.append(makeASensorItem(0x0170, 0, tr("Sewing thread breakage detection")));//缝纫断线检测
    sensorList.append(makeASensorItem(0x0174, 0, tr("Sewing scissors return")));//缝纫下剪刀回位
    sensorList.append(makeASensorItem(0x0186, 0, tr("The small plate closes signal 1")));//小台板关闭信号1
    sensorList.append(makeASensorItem(0x0186, 1, tr("The small plate closes signal 2")));//小台板关闭信号2
    //将机型所需的传感器列表替换到传感器整体列表中
    for(int i = 0; i < sensorList.size(); i++)
    {
        int byteaddr = sensorList[i].m_byte_offset;
        int bitaddr = sensorList[i].m_bit_offset;
        QString str = sensorList[i].m_name;
        int type = sensorList[i].m_type;

        int idx = byteaddr*8+bitaddr;
        if(idx < m_allSensorList.size())
        {
            m_allSensorList[idx].m_name = str;
            m_allSensorList[idx].m_type = type;
        }
    }
}

//初始化错误代码和状态列表
void TemplateSewMachine::initErrorCodeAndStateList()
{
    m_allErrorCodeAndStateList.clear();
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_HK_NOT_ZERO, tr("The shuttle is not at zero")));//旋梭不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_MS_NOT_SYNC, tr("Needle and shuttle is out of sync")));//旋转不同步
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_RO_NOT_SYNC, tr("Rotation is out of sync")));//旋转不同步
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_NEEDLE_NOT_HIGH, tr("The needle is not at the high position")));//机针不在高位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_LIFT_TIMEOUT, tr("Head lift timeout")));//机头升降超时
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_HEAD_NOT_SAFE, tr("The head is not in the safty area")));//机头不在安全区域
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_NOT_ZERO, tr("Punching head main shaft is not at zero")));//冲孔主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_R_LIT_POSI, tr("Rotating positive limit")));//正向旋转限位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_R_LIT_NEGA, tr("Rotating negative limit")));//反向旋转限位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_FOOT_POS, tr("Foot position error")));//压脚位置错误
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_FOOT_OUT_RANGE, tr("Foot moto's position is out of range")));//压脚电机位置越界
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_LIFT_OUT_RANGE, tr("The head lift moto's position is out of range")));//机头升降位置越界
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_ROT_OUT_RANGE, tr("Rotation position out of range")));//旋转位置越界
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_LIFT_ULIMIT, tr("Head lift upper limit")));// 机头升降上限位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_LIFT_DLIMIT, tr("Head lift down limit")));// 机头升降下限位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_EMB_NOT_ZERO, tr("Emb main shaft is not at zero")));// 平绣主轴不在零位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_SWND_TIMOUT, tr("Punching color change timeout")));// 冲孔换色超时
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_EMB_SWND_TIMOUT, tr("Embroidered color change timeout")));//平绣换色超时
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_EMB_ND_ERR, tr("Emb needle bar's position error")));//平绣针位错误
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_PUNCH_ND_ERR, tr("Punch needle bar's position error")));//冲孔针位错误
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_EMB_HOOK_NOT_ZERO, tr("Err emb hook not zero")));//平绣勾刀未回位
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_EMB_CUT_NOT_ZERO, tr("Err emb cut not zero")));//平绣剪刀未回位
}

